const FindsByBearing_DirectionsMax=60;
type  FindsByBearing_TypeInt=array[0..FindsByBearing_DirectionsMax] of integer;
      FindsByBearing_TypeExt=array[0..FindsByBearing_DirectionsMax] of extended;

// radarov grafy
function FindsByBearing_Radar(aPar:TStringList; aDirCount:FindsByBearing_TypeInt; aDirDist:FindsByBearing_TypeExt; iDirections:integer):string;
var
  i,ii,iSize,iMaxCount,iAxStep:integer;
  f,fAvgDist,fMaxAvgDist:extended;
  s,sD,sData,sLab,sChart,sType,sMax,sHome:string;
  bReduce:boolean;
begin
  // korekce velikosti grafu a vykreslovanch detail
  iSize:=iWidth;
  if (iSize*iSize) > MAX_GraphAreaSize then iSize:=Trunc(Sqrt(MAX_GraphAreaSize));
  bReduce:=((iSize<300) or (iDirections>24));

  // sestaven dat pro graf
  s:=aPar.Values['ValueType'];
  sType:=UpperCase(Fetch(s,'-'));
  for i:=0 to iDirections do begin
    // v radarovm grafu je posledn hodnota jako prvn, label je o jeden m
    if i=iDirections then ii:=0 else ii:=i;
    if aDirCount[ii]>iMaxCount then iMaxCount:=aDirCount[ii];
    if aDirCount[ii]>0 then fAvgDist:=aDirDist[ii]/aDirCount[ii] else fAvgDist:=0;
    if fAvgDist>fMaxAvgDist then fMaxAvgDist:=fAvgDist;
    case sType of
      'DISTANCE': sD:=FormatFloatDot('0',ConvertFromKm(0.5+fAvgDist,sUnit));
      'COUNT': sD:=IntToStr(aDirCount[ii]);
    end;
    if sData='' then sData:=sD else sData:=sData+','+sD;
    if i=iDirections then continue;
    if bReduce and ((Trunc(i*360/iDirections) mod 10)<>0) then 
      sLab:=sLab+'|.' 
    else 
      //URL ma obsahovat kodovani v UTF, je otazka, co tady vyleze z tech stupnu
      sLab:=sLab+'|'+EncodeGoogleLabel(IntToStr(i*360/iDirections)+' ');
  end;
  case sType of
    'DISTANCE': begin
      f:=ConvertFromKm(0.5+fMaxAvgDist,sUnit);
      sMax:=FormatFloatDot('0',f);
      iAxStep:=GraphAxisStep(f);  
    end;
    'COUNT': begin
      sMax:=IntToStr(iMaxCount);
      iAxStep:=GraphAxisStep(iMaxCount);  
    end;
  end;
  // vlastn graf
  sChart:='<img src="http://chart.googleapis.com/chart?cht=r'
         +'&chs='+IntToStr(iSize)+'x'+IntToStr(iSize)
         +'&chds=0,'+sMax
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')
         +'&chxt=x,y'
         +'&chxr=1,0,'+sMax+','+IntToStr(iAxStep)
         +'&chxs=0,'+GlobalVarGet('ColorMainText')+'|1,'+GlobalVarGet('ColorMainText')
         +'&chls=3,4,0'
         +'&chm=r,'+GlobalVarGet('ColorMainBkg')+'40,0,0,1|B,'
           +GlobalVarGet('ColorTableScaleAvgBkg')+'80,0,0,0|V,'
           +GlobalVarGet('ColorMainText')+'20,0,0.5::1,0.5';
  if sType='DISTANCE' then
    sChart:=sChart+'|@t['+GetLengthAbbr(sUnit)+'],'+GlobalVarGet('ColorMainText')+',0,2:0.9,12';
  s:=aPar.Values['HomeName'];
  if s<>'' then begin
    s:=ReplaceString(s,' ','+');      // nhrada jen mezer a rek, asi by to chtlo regulrn vraz... 
    s:=ReplaceString(s,',','\,');
    sHome:=s;
    // stle jet pokraovn parametru chm=
    sChart:=sChart+'|@t'+sHome+','+GlobalVarGet('ColorMainText')+',0,150:0.15,14'
         +'&chem=y;s=bubble_icon_text_big;d=home;po=0,0;of=-12,4';
  end;
  sChart:=sChart            
         +'&chd=t:'+sData
         +'&chxl=0:'+sLab
         +'" />';
  Output('<div style="text-align:center">'+CRLF);
  //vystup grafu musi byt kvuli kodovani (vzdy UTF) primo do vystupu
  //nahradime promenne a prevedeme na UTF
  //Result:=AnsiToUtf(sChart);
  Result:=sChart; //sLab uz ma polozky dekodovane do UTF
  fOut.Write(Result,Length(Result)); //rovnou vystup, aby nebylo prekodovano
  Output(CRLF+'</div>'); 
  Result:='';
end;

// hlavni funkce modulu
function FindsByBearing_Run(aPar:TStringList):string;
var 
  tab: TSqliteTable;
  i,j,iDirections:integer;
  fd,fdd,fds,fAvgDist:extended;
  s,sSql,sType,sOutType:string;
  aDirCount:FindsByBearing_TypeInt;
  aDirDist:FindsByBearing_TypeExt;
  aData:TStringList;
begin
  // poet smr, pro kter bude ve generovno
  iDirections:=StrToInt(aPar.Values['Directions']);
  Result:='';
  if(aPar.Values['Title']<>'') then begin
    Result:=ProcessCommand('CmdTitle',aPar);
    Output(Result);
    Result:='';
  end;
  sSql:='SELECT st.Angle Angle, st.Distance Distance FROM temp.Stator st, geocache gc'
    +' WHERE gc.id=st.id'
    +' AND gc.cachetype<>"Virtual Cache"'
    +' AND gc.cachetype<>"Locationless (Reverse) Cache"';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY Angle';
  i:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      Inc(i);
      fd:=StrToFloat(tab.FieldByName['Angle']);
      fds:=StrToFloat(tab.FieldByName['Distance']);
      fdd:=(fd+360/iDirections/2);
      if fdd>=360 then fdd:=fdd-360;          // modulo potebuje integer a zaokrouhlenm se interval zprava uzave
      j:=Trunc(fdd*iDirections/360);
      Inc(aDirCount[j]);
      aDirDist[j]:=aDirDist[j]+fds;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  //Log('Pocet selectem nactenych hodnot:'+IntToStr(i));
  // sestaven dat pro tabulku a vygenerovn vybranho typu vstupu
  s:=aPar.Values['ValueType'];
  sType:=Fetch(s,'-');
  aData:=TStringList.Create();
  try
    for i:=0 to iDirections-1 do begin
      aData.Add(IntToStr(i*360/iDirections)+'&deg;');
      if aDirCount[i]>0 then fAvgDist:=aDirDist[i]/aDirCount[i] else fAvgDist:=0;
      case UpperCase(sType) of
        'DISTANCE': aData.Add(FormatFloatDot('0',ConvertFromKm(0.5+fAvgDist,sUnit)));
        'COUNT': begin
          aData.Add(IntToStr(aDirCount[i]));
          aData.Add('?');
        end;
      end;
      aData.Add('?');
    end;
    s:=aPar.Values['OutputType'];
    sOutType:=Fetch(s,'-');
    case UpperCase(sOutType) of
      'TABLE': begin 
        case UpperCase(sType) of
          'DISTANCE': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Histogram',aData,0,iDirections,1,i)+CRLF;
          'COUNT': Result:=Result+OutputTableList(_('Azimuth')+'=center|'+sType+'|Percent=right|Histogram',aData,0,iDirections,1,i)+CRLF;
        end;
      end;
      'RADAR': begin
                 Result:=FindsByBearing_Radar(aPar,aDirCount,aDirDist,iDirections)+CRLF;
                 fOut.Write(Result,Length(Result));
                 Result:='';
               end;
    end;
  finally
    aData.Free();
  end;  
end;