type  FindsByBearingChallenge_Type=array[0..360] of integer;

//hlavni funkce modulu
function FindsByBearingChallenge_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,j,iSize,iCount,iLabDist:integer;
    fd:extended;
    s,sSql,sData,sChart,sChallenge:string;
    bReduce:boolean;
    aDir:FindsByBearingChallenge_Type;
begin
  Result:='';
  // korekce velikosti grafu a vykreslovanch detail
  iSize:=iWidth;
  if (iSize*iSize) > MAX_GraphAreaSize then iSize:=Trunc(Sqrt(MAX_GraphAreaSize));
  bReduce:=(iSize<400);
  if bReduce then iLabDist:=60 else iLabDist:=20;     // bacha, dva body grafu na vse!

  sSql:='SELECT st.Angle Angle FROM temp.Stator st, geocache gc'
    +' WHERE gc.id=st.id'
    +' AND gc.cachetype<>"Virtual Cache" AND gc.cachetype<>"Locationless (Reverse) Cache"';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY Angle';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      fd:=StrToFloat(tab.FieldByName['Angle']);
      j:=Trunc(fd)+1;
      Inc(aDir[j]);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  if aDir[1]>0 then sData:=sData+'5' else sData:=sData+'A';   // 5=Ano, A=Ne
  for i:=1 to 360 do begin
    if aDir[i]>0 then iCount:=iCount+1;
    if aDir[i]>0 then sData:=sData+'55' else begin
      sData:=sData+'A';
      if aDir[(i+1)mod 360]>0 then sData:=sData+'5' else sData:=sData+'A';
    end;
  end;
  
  if iCount<360 then sChallenge:=IntToStr(iCount) else sChallenge:=_('Challenge completed!');
  if (UpperCase(aPar.Values['HideChallengeValue'])='YES') then sChallenge:='';
  sChart:='<img src="http://chart.googleapis.com/chart?cht=r'
         +'&chs='+IntToStr(iSize)+'x'+IntToStr(iSize)
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chxt=x'
         +'&chxs=0,'+GlobalVarGet('ColorMainText')
         +'&chls=0'
         +'&chxr=0,0,360'
         +'&chm=B,'+GlobalVarGet('ColorTableScaleAvgBkg')+',0,0,0'
              +'|h,'+GlobalVarGet('ColorMainText')+'80,0,0.935,0.5,-1.0'
              +'|@o,'+GlobalVarGet('ColorTableScaleAvgBkg')+',0,0:0,100,1.0'
              +'|V,'+GlobalVarGet('ColorMainText')+'80,0,0:719:2,0.5,-1.0'
              +'|V,'+GlobalVarGet('ColorMainText')+'80,0,0:719:20,0.5,1.0'
              //URL ma byt v UTF, je otazka, co tady vyleze z tech stupnu
              //+'|N*x*%20'+EncodeGoogleLabel('')
              +'|N*x*' //vypada to divne, stupne tam nedame
                +','+GlobalVarGet('ColorMainText')+',0,0:719:'+IntToStr(iLabDist)+',12,,hv::0'
              +'|@t'+EncodeGoogleLabel(sChallenge)+','+GlobalVarGet('ColorMainText')+',0,0:0,30,1.0,hv'
         +'&chd=s:'+sData
         +'&chxl=0:|'
         +'" />';
  Result:=Result+'<div style="text-align:center">'
  Output(Result);
  fOut.Write(sChart,Length(sChart)); //rovnou vystup, aby nebylo prekodovano
  Result:='';
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    s:=ReplaceString(s,'%FoundSectors%',IntToStr(iCount));
    s:=ReplaceString(s,'%AllSectors%',IntToStr(360));
    s:='%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%';
  end;
  Output(s+'</div>'+CRLF);
end;