const FindsByDirection_Max=7;
type  FindsByDirection_Type=array[0..FindsByDirection_Max] of integer;
  
function FindsByDirection_RadarUtf(aDir:FindsByDirection_Type; iMax:integer):string;
var i,iMaxBar,iSize:integer;
    s,sData,sLab:string;
begin
  // korekce velikosti grafu a vykreslovanch detail
  iSize:=iWidth;
  if (iSize*iSize) > MAX_GraphAreaSize then iSize:=Trunc(Sqrt(MAX_GraphAreaSize));

  for i:=0 to FindsByDirection_Max do begin
    if aDir[i]>iMaxBar then iMaxBar:=aDir[i];
    s:=IntToStr(aDir[i]);
    if sData='' then sData:=s else sData:=sData+','+s;
    sLab:=sLab+'|'+EncodeGoogleLabel((GlobalVarGet('AbbrevDirection'+IntToStr(i*360/(FindsByDirection_Max+1))))+' ('+s+')');
  end;
  sData:=sData+','+IntToStr(aDir[0]);
  Result:='<div style="text-align:center">'
         +'<img src="http://chart.googleapis.com/chart?cht=r'
         +'&chs='+IntToStr(iSize)+'x'+IntToStr(iSize)
         +'&chds=0,'+IntToStr(iMaxBar)
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')
         +'&chxt=x'
         +'&chxs=0,'+GlobalVarGet('ColorMainText')
         +'&chls=3,4,0'
         +'&chm=B,'+GlobalVarGet('ColorTableScaleAvgBkg')+'80,0,0,0|h,'
           +GlobalVarGet('ColorMainText')+'80,0,0.9,0.5|h,'
           +GlobalVarGet('ColorMainText')+'80,0,0.5,0.5'
         +'&chd=t:'+sData
         +'&chxl=0:'+sLab
         +'" />'
         +'</div>';
  //sLab uz je preveden na UTF a do entit, proto neprevadet znova do UTF
  //Result:=AnsiToUtf(Result); //prevedeme na utf
end;

//hlavni funkce modulu
function FindsByDirection_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    aData:TStringList;
    i,j,iMax:integer;
    fd,fdd:extended;
    s,sType,sSql:string;
    aDir: FindsByDirection_Type;
begin
  Result:='';
  sSql:='SELECT st.Angle Angle FROM temp.Stator st, geocache gc'
    +' WHERE gc.id=st.id'
    +' AND gc.cachetype<>"Virtual Cache" AND gc.cachetype<>"Locationless (Reverse) Cache"';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY (22.5+st.Angle)';
  iMax:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      fd:=StrToFloat(tab.FieldByName['Angle']);
      fdd:=(fd+360/(FindsByDirection_Max+1)/2);
      if fdd>=360 then fdd:=fdd-360;          // modulo potebuje integer a zaokrouhlenm se interval zprava uzave
      j:=Trunc(fdd*(FindsByDirection_Max+1)/360);
      Inc(aDir[j]);
      if(aDir[j]>iMax) then iMax:=aDir[j];
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  aData:=TStringList.Create();
  try
    for i:=0 to FindsByDirection_Max do begin
      //text prvniho a posledniho radku je jiny
      aData.Add(IntToStr(i*360/(FindsByDirection_Max+1)));
      aData.Add(IntToStr(aDir[i]));
      aData.Add('?');
      aData.Add('?');
    end;
    sType:=aPar.Values['OutputType'];
    s:=Fetch(sType,'-');
    case UpperCase(s) of
    'TABLE':  begin
                Result:=Result+OutputTableList(
                  'Direction icon|Count|Percent|Histogram'
                  ,aData,0,8,1,i)+CRLF;
              end;
    'RADAR': begin
               Output(Result);
               Result:=FindsByDirection_RadarUtf(aDir,iMax)+CRLF;
               fOut.Write(Result,Length(Result));
               Result:='';
             end;
    end;
  finally
    aData.Free();
  end;  
end;