const FINDS_BY_DISTANCE_MAX=100;

function FindsByDistance_HistogramUtf(aDist,aMez:array of integer; nSteps:integer):string;
var i,iMinIdx,iMaxIdx,iMaxBar,iHeightGr,iWidthGr:integer;
    sData1,sData2,sD1,sD2,sLab1,sLab2,sL1,sL2,sMark,sM:string;
    bReduce:boolean;
begin
  // rozmry a parametry grafu
  iHeightGr:=200;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  // hranice pro redukci mnostv detail (popis na X ose) 
  bReduce:=((iWidth/nSteps)<26);        // doufm, e nSteps neme bt 0...
  //bReduce:=true;

  //zjistime nejvyssi a nejnizsi index s hodnotou
  iMinIdx:=-1;
  iMaxBar:=-1;
  for i:=0 to nSteps-1 do begin
    if((aDist[i]>0) and (iMinIdx<0)) then iMinIdx:=i;
    if(aDist[i]>0) then iMaxIdx:=i;
    if(aDist[i]>iMaxBar) then iMaxBar:=aDist[i];
  end;

  //mame 2 datove sety, abychom mohli nejvyssi hodnotu zobrazit jinou barvou nez zbytek
  for i:=iMinIdx to iMaxIdx do begin
    if(aDist[i]=iMaxBar) then begin
      sD1:='0';
      sD2:=IntToStr(aDist[i]);
    end else begin
      sD1:=IntToStr(aDist[i]);
      sD2:='0';
    end;
    if(sData1='') then sData1:=sD1 else sData1:=sData1+','+sD1;
    if(sData2='') then sData2:=sD2 else sData2:=sData2+','+sD2;

    if bReduce then begin
      if i=iMinIdx then sL1:='|'+EncodeUrlElement('<')+IntToStr(aMez[i+1])
      else if i=(iMinIdx+1) then sL1:='|'+IntToStr(aMez[i])+EncodeUrlElement('..')
      else if ((i-iMinIdx) mod 2)=1 then sL1:='|'
      else if i=iMaxIdx then sL1:='|'+EncodeUrlElement('>')+IntToStr(aMez[i])
      else sL1:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);
      if i=iMinIdx then sL2:='|'
      else if ((i-iMinIdx) mod 2)=0 then sL2:='|' 
      else if i=iMaxIdx then sL2:='|'+EncodeUrlElement('>')+IntToStr(aMez[i])
      else sL2:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);
    end else begin
      if i=iMinIdx then sL1:='|'+EncodeUrlElement('<')+IntToStr(aMez[i+1])
      else if i=(nSteps-1) then sL1:='|'+EncodeUrlElement('>')+IntToStr(aMez[i])
      else sL1:='|'+IntToStr(aMez[i])+EncodeUrlElement('..');    // popis se spodni mezi
      if(i=iMinIdx) then sL2:='|'
      else if(i=(nSteps-1)) then sL2:='|'
      else sL2:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);  // popis s horni mezi
    end;

    sLab1:=sLab1+sL1;
    sLab2:=sLab2+sL2;
    sM:='t'+IntToStr(aDist[i])+','+GlobalVarGet('ColorMainText')+',0,'+IntToStr(i-iMinIdx)+',10';
    if(aDist[i]=iMaxBar) then sM:='t'+IntToStr(aDist[i])+','+GlobalVarGet('ColorMainText')+',1,'+IntToStr(i-iMinIdx)+',10';
    if(sMark='') then sMark:=sM else sMark:=sMark+'|'+sM;
  end;
  Result:='<img src="http://chart.googleapis.com/chart?cht=bvs'
         +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)
         +'&chbh=a'
         +'&chds=0,'+IntToStr(Round(iMaxBar*1.1))+',0,'+IntToStr(Round(iMaxBar*1.1)) //data scale, rozsah v ose y trochu vetsi nez nejvyssi hodnota
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')+','+GlobalVarGet('ColorTableScaleMaxBkg')
         +'&chxt=x,x'
         +'&chxs=0,'+GlobalVarGet('ColorMainText')+'|1,'+GlobalVarGet('ColorMainText')
         +'&chd=t:'+sData1+'|'+sData2     //data
         +'&chxl=0:'+sLab1+'|1:'+sLab2
         +'&chm='+sMark
         +'" />';
  //sLab* uz jsou prevedeny do UTF a entit, proto znovu neprevadime do UTF
  //Result:=AnsiToUtf(Result); //prevedeme na utf
  //Log('Image Chart: '+Result);
end;

//hlavni funkce modulu
function FindsByDistance_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    aData:TStringList;
    i,iMin,iMinIdx,iMaxIdx,nRows,nSteps,nSuma:integer;
    fd,fSuma:extended;
    s,sType,sSql:string;
    aMez,aDist:array of integer;

begin
  SetLength(aMez,FINDS_BY_DISTANCE_MAX);
  SetLength(aDist,FINDS_BY_DISTANCE_MAX);
  s:=aPar.Values['Steps'];
  nSteps:=ReadStepsToArray(s,aMez);
  Result:='';
  sSql:='SELECT st.Distance FROM temp.Stator st, geocache gc'
    +' WHERE gc.id=st.id'
    +' AND gc.cachetype<>"Virtual Cache" AND gc.cachetype<>"Locationless (Reverse) Cache"';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+' ORDER BY (0+st.Distance) desc';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    fSuma:=0;
    nSuma:=0;
    while not tab.eof do begin
      fd:=StrToFloat(tab.FieldByName['Distance']);
      fSuma:=fSuma+fd;
      Inc(nSuma);
      iMin:=0;
      nRows:=0;
      for i:=0 to nSteps-1 do begin
        if(i=nSteps-1) and (fd>aMez[i]) then begin Inc(aDist[i]); break; end
        else if(fd>=aMez[i]) and (fd<aMez[i+1]) then begin
          Inc(aDist[i]);
//Log('XXXX fd='+floatToStr(fd)+', i='+IntToStr(i)+', H_mez='+IntToStr(aMez[i])+', pocet='+IntToStr(aDist[i]));
          break;
        end;
        iMin:=aMez[i];
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  //pokud je to potreba nahradime v titulku prumernou hodnotu
  if(nSuma=0) then nSuma:=1; //asi chybi kesky s nalezy
  if(aPar.Values['Title']<>'') then
    Result:=
      ReplaceString(ProcessCommand('CmdTitle',aPar),'%AvgValue%',
      FormatFloatDot('0',ConvertFromKm(0.5+(fSuma/nSuma),sUnit)));
  //zjistime nejmensi a nejvetsi index s hodnotou
  iMinIdx:=-1;
  for i:=0 to nSteps-1 do begin
//Log('AAAA aDist['+IntToStr(i)+']='+IntToStr(aDist[i])+' (hodnoty od '+IntToStr(aMez[i])+')');
    if((aDist[i]>0) and (iMinIdx<0)) then iMinIdx:=i;
    if(aDist[i]>0) then iMaxIdx:=i;
  end;
//Log('AAAA iMinIdx='+IntToStr(iMinIdx)+', iMaxIdx='+IntToStr(iMaxIdx));
  aData:=TStringList.Create();
  try
    iMin:=-9999;
    nRows:=0;
    for i:=iMinIdx to iMaxIdx do begin
      //text prvniho a posledniho radku je jiny
      if(i=nSteps-1) then aData.Add('>'+IntToStr(aMez[i]))
      else if(i=iMinIdx) then aData.Add('<'+IntToStr(aMez[i+1]))
      else aData.Add(IntToStr(aMez[i])+' - '+IntToStr(aMez[i+1]));
      aData.Add(IntToStr(aDist[i]));
      aData.Add('?');
      aData.Add('?');
      iMin:=aMez[i];
    end;
    sType:=aPar.Values['OutputType'];
    s:=Fetch(sType,'-');
    case UpperCase(s) of
    'TABLE':  begin
                Result:=Result+OutputTableList(
                  '%ColumnHeaderDistance%=center|Count|Percent|Histogram'
                  ,aData,0,(aData.Count/4),1,i)+CRLF;
              end;
    'HISTOGRAM': begin
                 Output(Result);
                 Result:=FindsByDistance_HistogramUtf(aDist,aMez,nSteps)+CRLF;
                 fOut.Write(Result,Length(Result));
                 Result:='';
                 end;
    end;
  finally
    aData.Free();
  end;  
end;