const FINDS_BY_ELEVATION_MAX=100;

function FindsByElevation_HistogramUtf(aData,aMez:array of integer; nSteps:integer):string;
var i,iMinIdx,iMaxIdx,iMaxBar,iHeightGr,iWidthGr:integer;
    sData1,sData2,sD1,sD2,sLab1,sLab2,sL1,sL2,sMark,sM:string;
    bReduce:boolean;
begin
  // rozmry a parametry grafu
  iHeightGr:=200;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  // hranice pro redukci mnostv detail (popis na X ose) 
  bReduce:=((iWidthGr/nSteps)<26);        // doufm, e nSteps neme bt 0...
  //bReduce:=false;
  
  //zjistime nejvyssi a nejnizsi index s hodnotou
  iMinIdx:=-1;
  iMaxBar:=-1;
  for i:=0 to nSteps-1 do begin
    if((aData[i]>0) and (iMinIdx<0)) then iMinIdx:=i;
    if(aData[i]>0) then iMaxIdx:=i;
    if(aData[i]>iMaxBar) then iMaxBar:=aData[i];
  end;

  //mame 2 datove sety, abychom mohli nejvyssi hodnotu zobrazit jinou barvou nez zbytek
  for i:=iMinIdx to iMaxIdx do begin
    if(aData[i]=iMaxBar) then begin
      sD1:='0';
      sD2:=IntToStr(aData[i]);
    end else begin
      sD1:=IntToStr(aData[i]);
      sD2:='0';
    end;
    if(sData1='') then sData1:=sD1 else sData1:=sData1+','+sD1;
    if(sData2='') then sData2:=sD2 else sData2:=sData2+','+sD2;

    if bReduce then begin
      if i=iMinIdx then sL1:='|'+EncodeUrlElement('<')+IntToStr(aMez[i+1])
      else if i=(iMinIdx+1) then sL1:='|'+IntToStr(aMez[i])+EncodeUrlElement('..')
      else if ((i-iMinIdx) mod 2)=1 then sL1:='|'
      //else if i=iMaxIdx then sL1:='|'+EncodeUrlElement('>')+IntToStr(aMez[i+1])
      else sL1:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);
      if i=iMinIdx then sL2:='|'
      else if ((i-iMinIdx) mod 2)=0 then sL2:='|' 
      //else if i=iMaxIdx then sL2:='|'+EncodeUrlElement('>')+IntToStr(aMez[i+1])
      else sL2:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);
    end else begin
      if i=iMinIdx then sL1:='|'+EncodeUrlElement('<')+IntToStr(aMez[i+1])
      else if i=(nSteps-1) then sL1:='|'+EncodeUrlElement('>')+IntToStr(aMez[i])
      else sL1:='|'+IntToStr(aMez[i])+EncodeUrlElement('..');    // popis se spodni mezi
      if(i=iMinIdx) then sL2:='|'
      else if(i=(nSteps-1)) then sL2:='|'
      else sL2:='|'+EncodeUrlElement('..')+IntToStr(aMez[i+1]);  // popis s horni mezi
    end;

    sLab1:=sLab1+sL1;
    sLab2:=sLab2+sL2;
    sM:='t'+IntToStr(aData[i])+','+GlobalVarGet('ColorMainText')+',0,'+IntToStr(i-iMinIdx)+',10';
    if(aData[i]=iMaxBar) then sM:='t'+IntToStr(aData[i])+','+GlobalVarGet('ColorMainText')+',1,'+IntToStr(i-iMinIdx)+',10';
    if(sMark='') then sMark:=sM else sMark:=sMark+'|'+sM;
  end;
  Result:='<img src="http://chart.googleapis.com/chart?cht=bvs'
         +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)
         +'&chbh=a'
         +'&chds=0,'+IntToStr(Round(iMaxBar*1.1))+',0,'+IntToStr(Round(iMaxBar*1.1)) //data scale, rozsah v ose y trochu vetsi nez nejvyssi hodnota
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')+','+GlobalVarGet('ColorTableScaleMaxBkg')
         +'&chxt=x,x'
         +'&chxs=0,'+GlobalVarGet('ColorMainText')+'|1,'+GlobalVarGet('ColorMainText')
         +'&chd=t:'+sData1+'|'+sData2     //data
         +'&chxl=0:'+sLab1+'|1:'+sLab2    //popisy osy
         +'&chm='+sMark                   //popisy sloupecku
         +'" />'+CRLF;
  //sLab* uz jsou prevedeny do UTF a entit, proto znovu neprevadime do UTF
  Result:=AnsiToUtf(Result); //prevedeme na utf
  //Log('Image Chart: '+Result);
end;

//hlavni funkce modulu
function FindsByElevation_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    aStr:TStringList;
    i,iMin,iMinIdx,iMaxIdx,nSuma,nSteps:integer;
    fd,fSuma:extended;
    s,sType,sSql:string;
    aMez,aData:array of integer;
    bMissElev:boolean;
begin
  SetLength(aMez,FINDS_BY_ELEVATION_MAX);
  SetLength(aData,FINDS_BY_ELEVATION_MAX);
  s:=aPar.Values['Steps'];
  nSteps:=ReadStepsToArray(s,aMez);
  Result:='';
  fSuma:=0;
  nSuma:=0;
  bMissElev:=false;
  sSql:='SELECT gtv.value Elevation, gc.id Id'
     +'     from geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'     where gt.id=gc.id' 
     +'     AND gc.cachetype<>"Virtual Cache" AND gc.cachetype<>"Locationless (Reverse) Cache"'
     +'     and gc.dtfound>0'
     +'     and gtc.key=gt.ptrkat and gtc.value=''Elevation'' and gtv.key=gt.ptrvalue';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';           
  sSql:=sSql+' ORDER BY (0+gtv.value) desc';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    //bErr:=false;
    while not tab.eof do begin
      s:=tab.FieldByName['Elevation'];
      if(s='') then begin
        Inc(iModuleError);
        Log(_('ERR: Elevation not defined')+' ('+tab.FieldByName['Id']+')');
        tab.Next();
        continue;
      end; 
      s:=ReplaceString(tab.FieldByName['Elevation'],',','.');
      if(s='') then bMissElev:=true
      else begin
        fd:=StrToFloat(s);
        fSuma:=fSuma+fd;
        Inc(nSuma);
        iMin:=0;
        for i:=0 to nSteps-1 do begin
          if(i=nSteps-1) and (fd>aMez[i]) then begin Inc(aData[i]); break; end
          else if(fd>=aMez[i]) and (fd<aMez[i+1]) then begin
            Inc(aData[i]);
  //Log('XXXX fd='+floatToStr(fd)+', i='+IntToStr(i)+', H_mez='+IntToStr(aMez[i])+', pocet='+IntToStr(aData[i]));
            break;
          end;
          iMin:=aMez[i];
        end;
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  if(nSuma=0) then begin
    nSuma:=1; //asi chybi tag
    s:=_('ERR: TAG Elevation missing. Start the plugin Elevation before running Stator!');
    AddError(s);
  end
  else begin
    //pokud je to potreba nahradime v titulku prumernou hodnotu
    if(aPar.Values['Title']<>'') then Result:=
      ReplaceString(ProcessCommand('CmdTitle',aPar),'%AvgValue%',
      FormatFloatDot('0.0',(fSuma/nSuma)));
    //zjistime posledni index s nenulovou hodnotou
    iMinIdx:=-1;
    iMaxIdx:=0;
    for i:=0 to nSteps-1 do begin
  //Log('BBBB aData['+IntToStr(i)+']='+IntToStr(aData[i])+' (hodnoty od '+IntToStr(aMez[i])+')');
      if(aData[i]>0) and (iMinIdx<0) then iMinIdx:=i;
      if(aData[i]>0) then iMaxIdx:=i;
    end;
    aStr:=TStringList.Create();
    try
  //Log('BBB iMinIdx='+IntToStr(iMinIdx)+', iMaxIdx='+IntToStr(iMaxIdx));
      iMin:=-9999;
      for i:=iMinIdx to iMaxIdx do begin
        //text prvniho a posledniho radku je jiny
        if(i=nSteps-1) then aStr.Add('>'+IntToStr(aMez[i]))
        else if(i=iMinIdx) then aStr.Add('<'+IntToStr(aMez[i+1]))
        else aStr.Add(IntToStr(aMez[i])+' - '+IntToStr(aMez[i+1]));
        aStr.Add(IntToStr(aData[i]));
        aStr.Add('?');
        aStr.Add('?');
        iMin:=aMez[i];
      end;
      sType:=aPar.Values['OutputType'];
      s:=Fetch(sType,'-');
  //Log('vystup: '+s);
      case UpperCase(s) of
      'TABLE':  begin
                  Result:=Result+OutputTableList(
                    'tag-Elevation=center|Count|Percent|Histogram'
                    ,aStr,0,(aStr.Count/4),1,i)+CRLF;
                end;
      'HISTOGRAM': begin
                     Output(Result);
                     Result:=FindsByElevation_HistogramUtf(aData,aMez,nSteps)+CRLF;
                     fOut.Write(Result,Length(Result));
                     Result:='';
                   end;
      end;
    finally
      aStr.Free();
    end;
    if(bMissElev) then begin
      AddError(_('Some caches have no Elevation tag (or it''s empty). List of these caches can be find in Stator.log file in active profile folder.'));
    end;
  end;
end;