function FindsByPie_Run(aPar:TStringList):string;
var
  sPar,sSql,sChartBy,sLabels,sL,sValues,sColors,sC,sPerc: string;
  i,iAllFounds,iValue,iHeightGr,iWidthGr: integer;
  tab: TSqliteTable;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:='';
  
  // rozmry a parametry grafu
  iHeightGr:=120;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);

  // parametry
  sPar:=aPar.Values['ChartBy'];
  sChartBy:=Fetch(sPar,'-');

  // celkov poet nlez
  iAllFounds:=StrToInt(GlobalVarGet('FoundCachesCount'));
  if iAllFounds=0 then exit;

  // vkonn st - select z databze a sestaven vstupu
  i:=0;
  case sChartBy of
  'WeekDay': sSql:='SELECT den WeekDay, count(den) cachecount FROM'
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho den v tydnu a prevedeme tak, aby 0 bylo pondeli
    +'  (SELECT ((strftime("%w",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))+6)%7) den'
    +'    FROM geocache where dtfound>0) x'
    +' group by den'
  else  sSql:='SELECT '+sChartBy+', count(*) cachecount FROM geocache '
          +' WHERE dtfound>0'
          +' GROUP BY '+sChartBy
          +' ORDER BY cachecount desc';
  end;
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    while not tab.eof do
    begin
      iValue:=StrToInt(tab.FieldByName['cachecount']);
      sPerc:=FormatFloatDot('0.0',iValue*100.0/iAllFounds);
      if(sChartBy='WeekDay') then sL:=GlobalVarGet('Day'+tab.FieldByName['WeekDay'])+' ('+sPerc+' %)'
      else sL:=tab.FieldByName[sChartBy]+' ('+sPerc+' %)';
      sC:=ScaleColor(iValue,0,iAllFounds,GlobalVarGet('ColorTableScaleMinBkg'),GlobalVarGet('ColorTableScaleAvgBkg'),GlobalVarGet('ColorTableScaleMaxBkg'));
      if (i mod 2)=0 then sC:=GlobalVarGet('ColorTableScaleAvgBkg') else sC:=GlobalVarGet('ColorTableScaleMinBkg');
      if i=0 then sC:=GlobalVarGet('ColorTableScaleMaxBkg');
      if sLabels='' then sLabels:=sL else sLabels:=sLabels+'|'+sL;
      if sValues='' then sValues:=sPerc else sValues:=sValues+','+sPerc;
      if sColors='' then sColors:=sC else sColors:=sColors+','+sC;
      Inc(i);
      tab.next;
    end;
  finally
    tab.free;
  end;

  // vstup do grafu
  Result:=AnsiToUtf('<img src="http://chart.googleapis.com/chart?cht=p3'
                +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)
                +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
                +'&chco='+sColors
                +'&chxt=x'
                +'&chxs=0,%ColorMainText%'
                +'&chds=a'
                +'&chd=t:'+sValues
                +'&chl='+sLabels
                +'">'+CRLF);
  fOut.Write(Result,Length(Result));
  Result:='';
end;