// Histogram nlez podle asu a podl lovu za svtla a za tmy. Vyaduje mt daje o asu a tag SvetloTma.

function FindsByTime_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,iDarkCount,iAllFounds,iLightPerc,iDarkPerc:integer;
    s,sType,sSql:string;
    iPieMin,iPieMinLeg,iRectMin,iHeightPie,iLightWd,iHeightGr,iWidthGr:integer;
    aTime:array[0..23] of integer;
    aData:TStringList;
begin
  Result:='';
  // rozmry a limitn hodnoty pro vykreslovn detail
  iHeightGr:=150;                   // vka grafu histogramu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  iHeightPie:=100;                  // vka kole svtlo/tma
  iPieMinLeg:=500;                  // minimln ka pro vykreslen kole s legendou
  iPieMin:=400;                     // minimln ka pro vykreslen kole bez resize
  iRectMin:=80;                     // minimln ka obdlnku (aby se do nj veel text)

  sSql:='SELECT dtfoundtime/100 Time, count(*) Num FROM geocache WHERE dtfound>0 GROUP BY Time';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      i:=StrToInt(tab.FieldByName['Time']);
      aTime[i]:=StrToInt(tab.FieldByName['Num']);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  aData:=TStringList.Create();
  for i:=0 to 23 do begin
    adata.Add(IntToStr(aTime[i]));
    adata.Add(IntToStr(i));
    adata.Add(IntToStr(aTime[i]));
  end;

  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:=OutputChartBarUtf(aData,iHeightGr,iWidthGr,0);
  fOut.Write(Result,Length(Result));
  Result:='';

  // podl nlez za svtla a za tmy
  sSql:=' SELECT count(*) as Svetlo'
       +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
       +' WHERE gt.id=gc.id and gc.dtfound>0'
       +'   AND gtc.key=gt.ptrkat'
       +'   AND gtc.value=''SvetloTma'''
       +'   AND gtv.key=gt.ptrvalue and gtv.value=''Tma''';
  iDarkCount:=Geoget_DB.GetTableValue(sSql);
  if iDarkCount=0 then exit;              // vykreslujeme jen pokud mme hodnoty z tagu SvetloTma

  iAllFounds:=StrToInt(GlobalVarGet('FoundCachesCount'));
  iDarkPerc:=Round(iDarkCount*100/iAllFounds);
  iLightPerc:=100-iDarkPerc;
  
  s:=aPar.Values['LightDarkType'];
  sType:=Fetch(s,'-');
  case sType of
  'Pie':  begin
      Result:=
        +'<img src="http://chart.googleapis.com/chart?cht=p3'
        +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
        +'&chco='+GlobalVarGet('ColorTableScaleMinBkg')+','+GlobalVarGet('ColorTableScaleMaxBkg')
        +'&chdls='+GlobalVarGet('ColorMainText')+',12'
        +'&chxt=x'
        +'&chxs=0,'+GlobalVarGet('ColorMainText')
        +'&chds=a'
        +'&chp=1'
        +'&chd=t:'+IntToStr(iLightPerc)+','+IntToStr(iDarkPerc);
      if iWidthGr>=iPieMinLeg then Result:=Result
        +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightPie)
        +'&chdl='+EncodeGoogleLabel(_('Finds in daylight'))+'|'+EncodeGoogleLabel(_('Finds at night'))
        +'&chl='+IntToStr(iAllFounds-iDarkCount)+' '+_('finds')+' ('+IntToStr(iLightPerc)+' %)|'
                +IntToStr(iDarkCount)+' '+_('finds')+' ('+IntToStr(iDarkPerc)+' %)'
      else if iWidthGr>=iPieMin then Result:=Result
        +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightPie)
        +'&chl='+EncodeGoogleLabel(_('Day')+': '+IntToStr(iAllFounds-iDarkCount)+' ('+IntToStr(iLightPerc)+' %)')+'|'
                +EncodeGoogleLabel(_('Night')+': '+IntToStr(iDarkCount)+' ('+IntToStr(iDarkPerc)+' %)')
      else Result:=Result
        +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(Round(iHeightPie*iWidthGr/iPieMin))
        +'&chl='+EncodeGoogleLabel(_('Day')+': '+IntToStr(iAllFounds-iDarkCount)+' ('+IntToStr(iLightPerc)+' %)')+'|'
                +EncodeGoogleLabel(_('Night')+': '+IntToStr(iDarkCount)+' ('+IntToStr(iDarkPerc)+' %)');
      Result:=Result+'">';
      //Result:=AnsiToUtf(Result); vse uz je prevedeno do UTF a entit neprevadet znovu
      fOut.Write(Result,Length(Result));
      Result:='';
    end;
  'Rectangles': begin
      iLightWd:=iWidthGr*iLightPerc/100;
      if iLightWd<iRectMin then iLightWd:=iRectMin;
      if (iWidthGr-iLightWd)<iRectMin then iLightWd:=iWidthGr-iRectMin;
      Result:='<div style="%StyleLightDark%">'+CRLF
        +'<table width="'+IntToStr(iWidthGr)+'" style="%StyleLightDarkTable%">'+CRLF
        +'  <tr><td width="'+IntToStr(iLightWd)+'" style="%StyleLightDarkTdLight%">'
        +_('Daylight')+'<br />'+IntToStr(iAllFounds-iDarkCount)+' ('+IntToStr(iLightPerc)+' %)</td>'+CRLF
        +'    <td style="%StyleLightDarkTdDark%">'
        +_('Night')+'<br />'+IntToStr(iDarkCount)+' ('+IntToStr(iDarkPerc)+' %)'
        +'</td>'+CRLF+'  </tr>'+CRLF+'</table>'+CRLF+'</div>'+CRLF;
      end;
  end;
  if(aData<>nil) then aData.Free();
end;