const
  MyOwnLife_GraphHeight=200;                             // vka grafu nlezu
  MyOwnLife_GraphEventHeight=120;                        // vka eventovho grafu
  MyOwnLife_GraphWidth=350;                              // ka grafu

function MyOwnLife_GetIdElement(sMainID:string; idx:integer):string;
begin
  Result:=sMainID+'_'+MyOwn_aCacheData[idx].sID;
end;

function MyOwnLife_GetFPPerc(idx:integer):string; //pomoci API zjisti pocet procent FP na kesi
//var
//  sSendData, sGetData: String;
//  aLogs:TStringList;
//  i,j,n,nPM,nStart,nKrok,nLogs,nFI: integer;
//  bLog:boolean;
begin
	//Log('Start MyOwnLife_GetFPPerc() - procenta FP pro '+MyOwn_aCacheData[idx].sId);
  Result:='';
  //funkce hodne zdrzuje a navic ma nejake limity pro pocet pristupu, takze kdyz
  //je hodne logu, musi se timeout pockat ... za tu cenu to nestoji
  {
	StatorBusy('MyOwnLife - '+MyOwn_aCacheData[idx].sId);
  //funkce je volana jen pri pozadovanych FP informacich
  //funkce je dostupna jen pro PM
  if(GlobalVarGet('CalcGS_UserMemberType')<>'Premium') then exit;
  //precteme vsechny logy na kesich, u kazdeho ligu jsou informace o typu uzivatele
  //vraci je od nejcerstvejsiho po nejstarsi log
  nStart:=0;
  nKrok:=300;
  nFI:=0;
  nPM:=0;
  bLog:=true;
  nLogs:=0;
  aLogs:=TStringList.Create();
  //MyOwn_aCacheData[idx].sId:='GC4V94G';
  try
    while bLog do begin //dokud je nejaky log nacten
      n:=GCliveCall(0, 'GetGeocacheLogsByCacheCode',
        'cacheCode='+MyOwn_aCacheData[idx].sId+'&startIndex='+IntToStr(nStart)+'&maxPerPage='+IntToStr(nKrok), sSendData, sGetData);
      sGetData:=Trim(ReplaceString(ReplaceString(UtfToAnsi(sGetData),CRLF,''),''+Chr($0A),''));
      //Log('XXXXX n='+IntToStr(n)+CRLF+ReplaceString(sGetData,'><','>'+CRLF+'<'));
      i:=0;
      //najdeme poce PM logujicich
      //sGetData:=ReplaceString(ReplaceString(sGetData,CRLF,''),'<a:MemberTypeId>3</a:MemberTypeId>',CRLF);
      sGetData:=ReplaceString(sGetData,'<a:GeocacheLog>',CRLF+'<a:GeocacheLog>');
      //Log('XXXXX n='+IntToStr(n)+CRLF+sGetData);
      aLogs.Text:=sGetData;
      i:=aLogs.Count;
      //projdeme kazdy log a u nalezovych pocitame PM uzivatele
      nStart:=nStart+nKrok;
      bLog:=false;
      for j:=0 to aLogs.Count-1 do begin
        bLog:=false;
        if(Pos('<a:GeocacheLog>',aLogs[j])>0) then begin
          Inc(nLogs);
          bLog:=true;
          if(Pos('<a:WptLogTypeId>2</a:WptLogTypeId>',aLogs[j])>0) then begin //nalezovy log
            Inc(nFI);
            if(Pos('<a:MemberTypeId>3</a:MemberTypeId>',aLogs[j])>0) then Inc(nPM); //PM
          end;
        end;
      end;
      //Log('MyOwnLife_GetFPPerc() - nLogs='+IntToStr(nLogs)+', nFI='+IntToStr(nFI)+' (nStart='+IntToStr(nStart)+', nKrok='+IntToStr(nKrok)+')');
    end;
    if(nPM>0) then begin
      Result:=' ('+FormatFloatDot('0.##',(100.*MyOwn_aCacheData[idx].nFP)/nPM)+' %)';
    end;
    Log('MyOwnLife_GetFPPerc() - iD='+MyOwn_aCacheData[idx].sId
      +', nLogs='+IntToStr(nLogs)+', nFIlogs='+IntToStr(nFI)
      +', FP='+IntToStr(MyOwn_aCacheData[idx].nFP)
      +', FI logovalo PM: '+IntToStr(nPM)+Result
      );
  finally
    aLogs.Free();
  end;
  }
end;

function MyOwnLife_Buttons(sMainItem:string):string;
var i:integer;
    s:string;
begin
  Result:='<div style="text-align:center; margin:15px;">'+CRLF
    +'<button id="'+sMainItem+'Show" style="cursor:pointer; margin:2px 2px 5px 2px; " onclick="';
  //zobrazeni vsech kesi
  for i:=Low(MyOwn_aCacheData) to High(MyOwn_aCacheData) do begin
    s:=MyOwnLife_GetIdElement(sMainItem,i);
    Result:=Result+'document.getElementById('''+s+''').style.display=''''; ';
  end;
  //doplnime zakazani tohoto tlacitka a povoleni druheho
  Result:=Result
    +'document.getElementById('''+sMainItem+'Show'').style.color='''+COLOR_BUT_INACTIVE_TXT+'''; '
    +'document.getElementById('''+sMainItem+'Hide'').style.color=''black''; '
    +'return false;">'+_('Show all caches')+'</button>'+CRLF;

  //zobrazeni kesi, ktere nejsou archivovane
  Result:=Result+'<button id="'+sMainItem+'Hide" style="cursor: pointer; color:'+COLOR_BUT_INACTIVE_TXT+';" onclick="';
  //zobrazeni vsech kesi
  for i:=Low(MyOwn_aCacheData) to High(MyOwn_aCacheData) do begin
    s:=MyOwnLife_GetIdElement(sMainItem,i);
    Result:=Result+'document.getElementById('''+s+''').style.display=';
    if(MyOwn_aCacheData[i].bArchived) then Result:=Result+'''none'';'
    else Result:=Result+''''';'
  end;
  //doplnime zakazani tohoto tlacitka a povoleni druheho
  Result:=Result
    +'document.getElementById('''+sMainItem+'Show'').style.color=''black''; '
    +'document.getElementById('''+sMainItem+'Hide'').style.color='''+COLOR_BUT_INACTIVE_TXT+'''; '
    +'return false;">'+_('Hide archived caches')+'</button>'+CRLF;
  Result:=Result+'</div>'+CRLF;
end;

procedure MyOwnLife_GraphCache(idx:integer; aPar:TStringList);
var 
  tab: TSqliteTable;
  i,iY,iM,iMax,iYearMin,iYearMax,iMonthMin,iMonthMax,iStepLabels:integer;
  s,ss,sD,sM,sT,sC,sF,sData,sDataX,sDis,sDisX,sArch,sArchX,sLabM,sLabY,sSql,sGraph,sLast,sFlags:string;
  bFirst,bStarted,bDisabled,bDisEnd,bArchived,bReduce:boolean;
  aData,aDisable,aFlags:TStringList;
begin
  // rozsahy vodorovn osy grafu
  s:=aPar.Values['Xscale'];
  ss:=Fetch(s,'-');
  case ss of
  'All':  begin
            iYearMin:=StrToInt(FormatDateTime('yyyy',MyOwn_dGraphFrom));
            iMonthMin:=StrToInt(FormatDateTime('m',MyOwn_dGraphFrom));
          end;
  else {'One'}  begin
            iYearMin:=StrToInt(FormatDateTime('yyyy',MyOwn_aCacheData[idx].dCreate));
            iMonthMin:=StrToInt(FormatDateTime('m',MyOwn_aCacheData[idx].dCreate));
          end;
  end;
  // konec vodorovn osy grafu
  s:=aPar.Values['EndOfGraph'];
  ss:=Fetch(s,'-');
  case ss of
  'EndOfLife':  begin
            iYearMax:=StrToInt(FormatDateTime('yyyy',MyOwn_aCacheData[idx].dLastFound));
            iMonthMax:=StrToInt(FormatDateTime('m',MyOwn_aCacheData[idx].dLastFound));
            if MyOwn_aCacheData[idx].dArchive>MyOwn_aCacheData[idx].dLastFound then begin
              iYearMax:=StrToInt(FormatDateTime('yyyy',MyOwn_aCacheData[idx].dArchive));
              iMonthMax:=StrToInt(FormatDateTime('m',MyOwn_aCacheData[idx].dArchive));
            end;
          end;
  else {'Today'}  begin
            iYearMax:=StrToInt(FormatDateTime('yyyy',Now()));
            iMonthMax:=StrToInt(FormatDateTime('m',Now()));
          end;
  end;

  // vytvooen zkladnch stringlistu pro data grafu
  iMax:=0;
  aData:=TStringList.Create();
  aDisable:=TStringList.Create();
  aFlags:=TStringList.Create();
  iY:=iYearMin;
  iM:=iMonthMin;
  while true do begin
    s:=IntToStr(iY)+IntToStr(iM);
    aData.Add(s+'=');
    aDisable.Add(s+'=');
    aFlags.Add(s+'=');
    Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if(((iY>=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax)) then break;
  end;
  
  // krok popisku vodorovn osy
  iStepLabels:=3;
  if aData.Count>48 then iStepLabels:=6;
  if aData.Count>60 then bReduce:=true;
  
  // hodnoty z logu vybran vlastn kee naplnme do pol
  sSql:='SELECT CAST(dt/100 AS INT) YearMonth, type LogType, count(*) Count '
       +'FROM geolog WHERE id='''+MyOwn_aCacheData[idx].sId+''' '
       +'GROUP BY YearMonth, LogType '
       +'ORDER BY dt,gs_logid ASC';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iY:=StrToInt(Copy(s,1,4));
      iM:=StrToInt(Copy(s,5,2));
      sM:=IntToStr(iY)+IntToStr(iM);
      sT:=tab.FieldByName['LogType'];
      sC:=tab.FieldByName['Count'];
      s:=aFlags.Values[sM];
      ss:=aDisable.Values[sM];
      case sT of
      'Found it',
      'Webcam Photo Taken':           begin
                                        iMax:=iMax+StrToInt(sC);
                                        aData.Values[sM]:=IntToStr(iMax);
                                      end;
      'Temporarily Disable Listing':  aDisable.Values[sM]:=ss+'D';
      'Enable Listing':               aDisable.Values[sM]:=ss+'E';
      'Archive':                      aFlags.Values[sM]:=s+'Ar';
      'Unarchive':                    aFlags.Values[sM]:=s+'Un';
      'Needs Maintenance':            aFlags.Values[sM]:=s+'Nm';
      'Owner Maintenance':            aFlags.Values[sM]:=s+'Ma';
      'Needs Archived':               aFlags.Values[sM]:=s+'Na';
      end;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // rozsahy svisl osy grafu
  s:=aPar.Values['Yscale'];
  ss:=Fetch(s,'-');
  case ss of
  'All':  iMax:=MyOwn_iMax;
  end;
  iMax:=Round(iMax*1.1);         // prava celkovho rozsahu, aby byly vidit praporky 

  if(aData.Count<=1) or (iMax=0) then begin
    AddError(_('WARN: Zero Found It logs for')+' '+MyOwn_aCacheData[idx].sId
      +'. '+_('You must get logs from geocaching.com!'));
    exit;
  end;

  // generovn datovch ad a popisu pro graf
  bFirst:= true; bStarted:=false; bDisabled:=false; bDisEnd:=false;
  iY:=iYearMin;      
  iM:=iMonthMin;
  i:=0;
  while true do begin
    s:=IntToStr(iY)+IntToStr(iM);
    sC:=aData.Values[s];
    sD:=aDisable.Values[s];
    sF:=aFlags.Values[s];
    if sC<>'' then sLast:=sC;
    // pln prvn bod
    if bFirst and (sC<>'') and not bStarted then begin
      sData:=sData+EncodeNormDataExtended(0,iMax);
      sDataX:=sDataX+EncodeNormDataExtended(i,aData.Count-1);
      bStarted:=true;
      bFirst:=false;
    end;
    // zakonen Disable->Enable v rmci jednoho msce
    if bDisEnd then begin
      sDis:=sDis+EncodeNormDataExtended(StrToInt(sLast),iMax);
      sDisX:=sDisX+EncodeNormDataExtended(i,aData.Count-1);
      sDis:=sDis+'__';            // zakonen ry neex. hodnotou
      sDisX:=sDisX+'__';
      bDisEnd:=false;
    end;
    // bn ivotn stav
    if bStarted then begin
      sData:=sData+EncodeNormDataExtended(StrToInt(sLast),iMax);
      sDataX:=sDataX+EncodeNormDataExtended(i,aData.Count-1);
      //if (sD='D') or (sD='ED') then begin
      if RegexFind('.*D\Z',sD) then begin
        sData:=sData+'__';        // zakonen ry neex. hodnotou
        sDataX:=sDataX+'__';
        bStarted:=false;
        bDisabled:=true;
      end;
      //if sD='DE' then begin       // Disable->Enable v rmci jednoho msce
      if RegexFind('.*D.*E\Z',sD) then begin
        sDis:=sDis+EncodeNormDataExtended(StrToInt(sLast),iMax);
        sDisX:=sDisX+EncodeNormDataExtended(i,aData.Count-1);
        bDisEnd:=true;
      end;
    end;
    // stav disable
    if bDisabled then begin
      sDis:=sDis+EncodeNormDataExtended(StrToInt(sLast),iMax);
      sDisX:=sDisX+EncodeNormDataExtended(i,aData.Count-1);
      //if (sD='E') or (sD='DE') then begin
      if RegexFind('.*E\Z',sD) then begin
        sDis:=sDis+'__';          // zakoneen ry neex. hodnotou
        sDisX:=sDisX+'__';
        sData:=sData+EncodeNormDataExtended(StrToInt(sLast),iMax);
        sDataX:=sDataX+EncodeNormDataExtended(i,aData.Count-1);
        bStarted:=true;
        bDisabled:=false;
      end;
    end;
    // pepnut na stav archivovno
    if Pos('Ar',sF)>0 then begin 
      sFlags:=sFlags+'|@fArchive,000000,0,'
                    +FormatFloatDot('0.00',i*1.0/(aData.Count-1))+':'
                    +FormatFloatDot('0.00',StrToInt(sLast)*1.0/iMax)+',12,1';
      sData:=sData+'__';          // zakoneen ery neex. hodnotou
      sDataX:=sDataX+'__';
      sDis:=sDis+'__';            // zakoneen ery neex. hodnotou
      sDisX:=sDisX+'__';
      bStarted:=false;
      bDisabled:=false;
      bArchived:=true;
    end;
    // stav archivovno
    if bArchived then begin
      sArch:=sArch+EncodeNormDataExtended(StrToInt(sLast),iMax);
      sArchX:=sArchX+EncodeNormDataExtended(i,aData.Count-1);
      // odarchivace
      if Pos('Un',sF)>Pos('Ar',sF) then begin
        sFlags:=sFlags+'|@fUnarchive,000000,0,'
                      +FormatFloatDot('0.00',i*1.0/(aData.Count-1))+':'
                      +FormatFloatDot('0.00',StrToInt(sLast)*1.0/iMax)+',12';
        sArch:=sArch+'__';        // zakoneen ery neex. hodnotou
        sArchX:=sArchX+'__';
        // po odarchivovn zanme jako enable
        sData:=sData+EncodeNormDataExtended(StrToInt(sLast),iMax);
        sDataX:=sDataX+EncodeNormDataExtended(i,aData.Count-1);
        bStarted:=true;
        bArchived:=false;
      end;
    end;
    // popisy vodor. osy
    if (iM mod iStepLabels)=0 then sLabM:=sLabM+'|'+IntToStr(iM) else sLabM:=sLabM+'|';
    if iM=6 then sLabY:=sLabY+'|'+IntToStr(iY) else sLabY:=sLabY+'|';
    Inc(i); Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if(((iY>=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax)) then break;
  end;

  // finln sestaven URL grafu
  sGraph:='<img src="http://chart.googleapis.com/chart?cht=lxy'
         +'&chs='+IntToStr(MyOwnLife_GraphWidth)+'x'+IntToStr(MyOwnLife_GraphHeight)
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorGraphCacheEnabled')+','
           +GlobalVarGet('ColorGraphCacheDisabled')+','
           +GlobalVarGet('ColorGraphCacheArchived')
         +'&chg=0,'+FormatFloatDot('0.00',GraphAxisStep(iMax*2)*100.0/iMax)+',3,3,0,0'
         +'&chds=0,'+IntToStr(iMax)
         +'&chxs=0,'+GlobalVarGet('ColorMainText')+',12|1,'
           +GlobalVarGet('ColorMainText')
           +',12|2,'+GlobalVarGet('ColorMainText')+',12'
         +'&chxr=1,0,'+IntToStr(iMax)+','+IntToStr(GraphAxisStep(iMax*2))
         +'&chls=3,4,0|3,4,0|3,4,2'
         +'&chm=B,'+GlobalVarGet('ColorGraphCacheEnabled')+'80,0,0,0|B,'
           +GlobalVarGet('ColorGraphCacheDisabled')+'A0,1,0,0'+sFlags
         +'&chd=e:'+sDataX+','+sData+','+sDisX+','+sDis+','+sArchX+','+sArch;
  if bReduce then sGraph:=sGraph
         +'&chxt=x,y'
         +'&chxl=0:'+sLabY
  else sGraph:=sGraph
         +'&chxt=x,y,x'
         +'&chxl=0:'+sLabM+'|2:'+sLabY;
  sGraph:=sGraph
         +'&chdlp=t'
         +'&chdls='+GlobalVarGet('ColorMainText')+',12'
         +'&chdl='+EncodeGoogleLabel(_('Enabled'))+'|'+EncodeGoogleLabel(_('Disabled'))
         +'" />'+CRLF;
  //vse uz je prevedeno do UTF a entit, neprevadet znovu
  //sGraph:=AnsiToUtf(sGraph);  // prevedeme na utf
  fOut.Write(sGraph,Length(sGraph));

  // klid
  if(aData<>nil) then aData.Free();
  if(aDisable<>nil) then aDisable.Free();
  if(aFlags<>nil) then aFlags.Free();
end;

procedure MyOwnLife_GraphEvent(idx:integer; aPar:TStringList);
var 
  s,sSql,sGraph:string;
  iWill,iAtt,iBoth:integer;
begin
  // zkladn hodnoty pro Venn Chart
  iWill:=MyOwn_aCacheData[idx].nWillAttend;
  iAtt:=MyOwn_aCacheData[idx].nFoundIt;
  // poet nicku, kte logovali Will Attend i Attended
  s:=MyOwn_aCacheData[idx].sID;
  sSql:='SELECT COUNT(finder) FROM geolog WHERE finder IN (SELECT finder FROM geolog '
       +'WHERE type=''Will Attend'' AND id='''+s+''') AND type=''Attended'' AND id='''+s+'''';
  iBoth:=Geoget_DB.GetTableValue(sSql);

  // finln sestaven URL grafu
  sGraph:='<img src="http://chart.googleapis.com/chart?cht=v'
         +'&chs='+IntToStr(MyOwnLife_GraphWidth)+'x'+IntToStr(MyOwnLife_GraphEventHeight)
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')+','+GlobalVarGet('ColorGraphCacheEnabled')+'80'
         +'&chd=t:'+IntToStr(iWill)+','+IntToStr(iAtt)+',0,'+IntToStr(iBoth)
         +'&chdlp=t'
         +'&chdls='+GlobalVarGet('ColorMainText')+',12'
         +'&chdl='+EncodeGoogleLabel(_('Will Attend'))+'|'+EncodeGoogleLabel(_('Attended'))
         +'" />'+CRLF;
  //vse uz je prevedeno do UTF a entit, neprevadet znovu
  //sGraph:=AnsiToUtf(sGraph);  // prevedeme na UTF
  fOut.Write(sGraph,Length(sGraph));
end;

function MyOwnLife_MakeLinkToProfile(sNicks:string):string;
var s:string;
begin
  Result:='';
  while(sNicks<>'') do begin
    s:=Fetch(sNicks,'|');
    if(Result<>'') then Result:=Result+', ';
    Result:=Result+'<a href="http://www.geocaching.com/profile/default.aspx?u='
      +EncodeUrlElement(AnsiToUtf(s))+'" target="_blank">'+s+'</a>';
  end;
end;

procedure MyOwnLife_TableCache(idx:integer; aPar:TStringList);
var s:string;
    iWold:integer;
    bOdd:boolean;
begin
  iWold:=iWidth;
  iWidth:=iWidth-MyOwnLife_GraphWidth-10;
  GlobalVarSet('Width',IntToStr(iWidth));
  s:='<table style="margin:0px auto 0px auto; '+GlobalVarGet('StyleTableNum')+'">'+CRLF;
  
  bOdd:=false;
  //odlisime logy pro normalni a eventove kese
  if(MyOwn_aCacheData[idx].bEvent) then begin
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Will Attend')+'</td><td style="%StyleTableNumTd%"><b>'
      +IntToStr(MyOwn_aCacheData[idx].nWillAttend)+'</b></td></tr>';
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Attended')+'</td><td style="%StyleTableNumTd%"><b>'
      +IntToStr(MyOwn_aCacheData[idx].nFoundIt)+'</b></td></tr>';
  end
  else begin
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Found it')+'</td><td style="%StyleTableNumTd%"><b>'
      +IntToStr(MyOwn_aCacheData[idx].nFoundIt)+'</b></td></tr>';
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('DNF')+'</td><td style="%StyleTableNumTd%"><b>'
      +IntToStr(MyOwn_aCacheData[idx].nDNF)+'</b></td></tr>';
  end;
  if(not MyOwn_aCacheData[idx].bEvent) then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Cache succes')+'</td><td style="%StyleTableNumTd%"><b>'
      +FormatFloatDot('0.00',(0.0+MyOwn_aCacheData[idx].nFoundIt)/MyOwn_aCacheData[idx].nExistDays)
      +'</b> '+_('finds per day')+'</td></tr>';
  if(not MyOwn_aCacheData[idx].bEvent) then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Published')+'</td><td style="%StyleTableNumTd%"><b>'+DateToStr(MyOwn_aCacheData[idx].dPublic)
      +'</b> ('+_('Created:')+' <b>'+DateToStr(MyOwn_aCacheData[idx].dCreate)+'</b>)</td></tr>'
  else
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Date of event')+'</td><td style="%StyleTableNumTd%"><b>'+DateToStr(MyOwn_aCacheData[idx].dCreate)
      +'</b></td></tr>';
  if(not MyOwn_aCacheData[idx].bEvent) then begin
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Last find')+'</td><td style="%StyleTableNumTd%"><b>'+DateToStr(MyOwn_aCacheData[idx].dLastFound)+'</b></td></tr>';
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Days hidden')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(MyOwn_aCacheData[idx].nExistDays)
      +'</b> '+_('days')+'</td></tr>';
  end;
  if(MyOwn_aCacheData[idx].nLogs=0) then MyOwn_aCacheData[idx].nLogs:=1;
  s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
    +'<td style="%StyleTableNumTd%">'+_('Logs')+'</td><td style="%StyleTableNumTd%"><b>'+IntToStr(MyOwn_aCacheData[idx].nLogs)+'</b>';
  if(MyOwn_Param.bWordLogs) then
    s:=s+'; '+_('Average log length')+' '
      +'<b>'+FormatFloatDot('0.00',(0.0+MyOwn_aCacheData[idx].nWordsTotal)/MyOwn_aCacheData[idx].nLogs)
      +'</b> '+_('words')
  else s:=s+'</td></tr>';
  if(MyOwn_Param.bWordLogs) then begin
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Longest log')+'</td><td style="%StyleTableNumTd%">'
      +'<a href="http://www.geocaching.com/seek/log.aspx?LID='+MyOwn_aCacheData[idx].sWordsMaxLID+'" target="_blank">'
      +'<b>'+IntToStr(MyOwn_aCacheData[idx].nWordsMax)+'</b></a> '+_('words')
      +' ('+MyOwnLife_MakeLinkToProfile(MyOwn_aCacheData[idx].sWordsMaxFinder)+')'
      +'</td></tr>';
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Shortest log')+'</td><td style="%StyleTableNumTd%">'
      +' <a href="http://www.geocaching.com/seek/log.aspx?LID='+MyOwn_aCacheData[idx].sWordsMinLID+'" target="_blank">'
      +'<b>'+IntToStr(MyOwn_aCacheData[idx].nWordsMin)+'</b></a> '+_('words')
      +' (<a href="http://www.geocaching.com/profile/default.aspx?u='+MyOwn_aCacheData[idx].sWordsMinFinder+'" target="_blank">'
      +MyOwn_aCacheData[idx].sWordsMinFinder+'</a>)'
      +'</td></tr>';
  end;
  if((MyOwn_Param.bFP) and (not MyOwn_aCacheData[idx].bEvent)) then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('Favorite points')+'</td><td style="%StyleTableNumTd%"><b>'
      //FP % trva dlouho a ma limit na pocet pristupu, nestoji to za tu "cenu"
      +IntToStr(MyOwn_aCacheData[idx].nFP)+{MyOwnLife_GetFPPerc(idx)+}'</b></td></tr>';
  if(aPar.Values['GCVote']='Yes') then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('GC Vote')+'</td><td style="%StyleTableNumTd%"><b>'
      +IntToStr(MyOwn_aCacheData[idx].nGCVoteCount)+'</b>'
      +' (median: <b>'+FormatFloatDot('0.0',MyOwn_aCacheData[idx].fGCVoteMedian)+'</b>)'
      +'</td></tr>';
{
    s:=s+'&nbsp;&nbsp;&nbsp;'+IntToStr(MyOwn_aCacheData[idx].nFP)+'  <img src="%IconLayoutFavorites%" />';
    +'&nbsp;&nbsp;&nbsp;'+IntToStr(MyOwn_aCacheData[idx].nGCVoteCount)+'  <img src="%IconLayoutGCVote%" />'
}  
  if(MyOwn_aCacheData[idx].sFTF<>'') then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('FTF')+'</td><td style="%StyleTableNumTd%"><b>'
      +MyOwnLife_MakeLinkToProfile(MyOwn_aCacheData[idx].sFTF)+'</b></td></tr>';
  if(MyOwn_aCacheData[idx].sSTF<>'') then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('STF')+'</td><td style="%StyleTableNumTd%"><b>'
      +MyOwnLife_MakeLinkToProfile(MyOwn_aCacheData[idx].sSTF)+'</b></td></tr>';
  if(MyOwn_aCacheData[idx].sTTF<>'') then
    s:=s+'  <tr style="%StyleTableNumTr%">'+CRLF
      +'<td style="%StyleTableNumTd%">'+_('TTF')+'</td><td style="%StyleTableNumTd%"><b>'
      +MyOwnLife_MakeLinkToProfile(MyOwn_aCacheData[idx].sTTF)+'</b></td></tr>';
  s:=s+'</table>'+CRLF;
  Output(s);
  iWidth:=iWold;
  GlobalVarSet('Width',IntToStr(iWidth));
end;

function MyOwnLife_TableLogs(idx:integer):string;
var sSql:string;
    tab:TSQLiteTable;
begin
    Result:='<p style="text-align:center;">';
    GEOGET_DB.AddParamText(':id',MyOwn_aCacheData[idx].sId);
    sSql:='SELECT count(type), type FROM geolog where id=:id group by type order by count(type) desc '
    tab:=GEOGET_DB.GetTable(sSql, false);
    try
      while (not tab.Eof) do begin
        Result:=Result//+'<td>'
          +'<img src="%IconCacheLog'+tab.FieldAsString(1)+'%" title="'+tab.FieldAsString(1)+'" />'+tab.FieldAsString(0)
          //+'</td>'+CRLF;
          +'&nbsp;&nbsp;&nbsp;';
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    Result:=Result+'</p>'+CRLF;
end;

procedure MyOwnLife_MonthYear(idx:integer; aPar:TStringList);
var s,sTab,sSql:string;
    tab:TSQLiteTable;
    iM,iR,iRmin,iRmax,nR,i,iMax:integer;
    aFinds: array of integer;
begin
  //vytvori tabulku mesic/rok s poctem nalezu v kazdem policku
  //zjistime nejnizsi, nejvyssi rok a pocet roku do tabulky
  GEOGET_DB.AddParamText(':id',MyOwn_aCacheData[idx].sId);
  sSql:='SELECT distinct substr(dt,1,4) FROM geolog where id=:id and type=''Found it'' group by substr(dt,1,4) order by substr(dt,1,4) asc';
  tab:=GEOGET_DB.GetTable(sSql, false);
  try
    iRmin:=tab.FieldAsInteger(0);
    while (not tab.Eof) do begin
      iRmax:=tab.FieldAsInteger(0);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  nR:=iRmax-iRmin+1;
  iMax:=0;

  //nastavime velikost pole pro data
  SetLength(aFinds,(nR+1)*13);
  //nacteme pocty nalezu v jednotlivych mesicich
  GEOGET_DB.AddParamText(':id',MyOwn_aCacheData[idx].sId);
  sSql:='SELECT count(id), substr(dt,1,4), substr(dt,5,2) FROM geolog where id=:id and type=''Found it'' group by substr(dt,1,6) order by substr(dt,1,6) asc';
  tab:=GEOGET_DB.GetTable(sSql, false);
  try
    while (not tab.Eof) do begin
      i:=tab.FieldAsInteger(0);
      if(iMax<i) then iMax:=i;       //maximalni pocet nalezu za mesic
      iR:=tab.FieldAsInteger(1);
      iM:=tab.FieldAsInteger(2);
      aFinds[(iR-iRmin)*13+iM-1]:=i; //ulozime pocet nalezu v mesici
      aFinds[(iR-iRmin)*13+12]:=aFinds[(iR-iRmin)*13+12]+i; //pocitame nalezy v roce
      aFinds[nR*13+iM-1]:=aFinds[nR*13+iM-1]+i; //pocitame nalezy v mesici
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  //hlavicka tabulky
  sSql:=GlobalVarGet('ColumnHeaderYear'); //udelame svisly text
  //if bCond then begin //udelame svisly text
  s:='';
  for i:=1 to Length(sSql) do begin
    s:=s+'&nbsp;'+sSql[i]+'&nbsp;<br />';
  end;
  //end;
  sTab:=sTab+'<br /><p style="text-align:center; font-weight:bold;">'+_('Finds overview')+'</p>'
    +'<table style="'+GlobalVarGet('StyleTableMatrix')+'">'+CRLF;
  sTab:=ReplaceString(sTab,'%Width%',IntToStr(iWidth)); //maximalni sirak tabulky
  //sTab:=ReplaceString(sTab,'%Width%','auto'); //minimalni rirka tabulky
  sTab:=sTab
    +'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh1%">&nbsp;</th><th colspan=14 style="%StyleTableMatrixTh1%">%MonthMonth%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'
    +'    <th rowspan='+IntToStr(nR+2)+' style="%StyleTableMatrixTh1Down%">'+s+'</th>'
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthJan%</th><th style="%StyleTableMatrixTh2%">%MonthFeb%</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthMar%</th><th style="%StyleTableMatrixTh2%">%MonthApr%</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthMa%</th><th style="%StyleTableMatrixTh2%">%MonthJun%</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthJul%</th><th style="%StyleTableMatrixTh2%">%MonthAug%</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthSep%</th><th style="%StyleTableMatrixTh2%">%MonthOct%</th>'
    +'    <th style="%StyleTableMatrixTh2%">%MonthNov%</th><th style="%StyleTableMatrixTh2%">%MonthDec%</th>'
    +'    <th style="%StyleTableMatrixTh2%">&sum;</th>'
    +'  </tr>'+CRLF;

  //vytvorime datove radky tabulky
  for iR:=0 to nR-1 do begin
    sTab:=sTab+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">'+IntToStr(iRmin+iR)+'</th>'+CRLF;
    for iM:=0 to 11 do begin
      i:=iR*13+iM;
      if(aFinds[i]=0) then sTab:=sTab+'<td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else sTab:=sTab+'    <td style="%StyleTableMatrixTd% background:#'
        +ScaleColor(aFinds[i],0,iMax,GlobalVarGet('ColorTableScaleMinBkg'),GlobalVarGet('ColorTableScaleAvgBkg'),GlobalVarGet('ColorTableScaleMaxBkg'))
        +'">'+IntToStr(aFinds[i])+'</td>'+CRLF;
    end;
    sTab:=sTab+'  <th style="%StyleTableMatrixTh2%">'+IntToStr(aFinds[iR*13+12])+'</th></tr>'+CRLF;
  end;

  //doplnime soucty za jednotlive mesice
  sTab:=sTab+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  i:=0;
  for iM:=0 to 11 do begin
    i:=i+aFinds[nR*13+iM];
    sTab:=sTab+'<th style="%StyleTableMatrixTh2%">'+IntToStr(aFinds[nR*13+iM])+'</th>'+CRLF
  end;
  sTab:=sTab+'<th style="%StyleTableMatrixTh2%">'+IntToStr(i)+'</th>'+CRLF;
  sTab:=sTab+'  </tr>'+CRLF;
  sTab:=sTab+'</table>'+CRLF;
  Output(sTab);
  SetLength(aFinds,0);
end;

procedure MyOwnLife_OutputCache(idx:integer; sMainItem:string; aPar:TStringList);
var s,sOut:string;
begin
  //protoze je to tu pomale, zobrazime informaci o tom, co delame
  StatorBusy(IntToStr(idx)+'/'+IntToStr(High(MyOwn_aCacheData))+'  '+
    MyOwn_aCacheData[idx].sId+' - '+MyOwn_aCacheData[idx].sName);
  //zkonstruujeme nadpis
  s:='<div style="%StyleMyOwnCacheTitle1%">'
    +MakeHtmlCacheInfo(MyOwn_aCacheData[idx].sId,
      MyOwn_aCacheData[idx].sType,MyOwn_aCacheData[idx].sName,'',IntToStr(MyOwn_aCacheData[idx].iStatus))
    +'</div>'+CRLF
    +'<div style="%StyleMyOwnCacheTitle2%">'
    +'%ColumnHeaderSize%: <img src="%IconCacheSize'+MyOwn_aCacheData[idx].sSize+'%" '
    +'title="'+MyOwn_aCacheData[idx].sSize+'" />&nbsp;&nbsp;'
    +'%ColumnHeaderDifficulty%: <img src="%IconCacheDiff'+MyOwn_aCacheData[idx].sDifficult+'%" '
    +'title="'+MyOwn_aCacheData[idx].sDifficult+'" />&nbsp;&nbsp;'
    +'%ColumnHeaderTerrain%: <img src="%IconCacheTerr'+MyOwn_aCacheData[idx].sTerrain+'%" '
    +'title="'+MyOwn_aCacheData[idx].sTerrain+'" />&nbsp;&nbsp;'
    +ReplaceString(ReplaceString(GlobalVarReplace('%ColumnHeadertag-Elevation%: '),'<br />',' '),'<br />',' ')
    +MyOwn_aCacheData[idx].sElevation
    +' m</div>';
  aPar.Values['Title']:=s;
  s:=ProcessCommand('CmdTitle',aPar);
  sOut:='<div id="'+MyOwnLife_GetIdElement(sMainItem,idx)+'" ';//ID divu pro skryti kese
  //pokud je kes archivovana, nastavime ji neviditelnou
  if(MyOwn_aCacheData[idx].bArchived) then sOut:=sOut+'style="display:none;"';
  sOut:=sOut+'>'+CRLF+s;
  Output(sOut);
  Output(MyOwnLife_TableLogs(idx));         //vytvorime prehled logu
  // graf pomo zapisuje do vstupu!
  Output('<table><tr><td>');
  if(not MyOwn_aCacheData[idx].bEvent) then
    MyOwnLife_GraphCache(idx, aPar)
  else
    MyOwnLife_GraphEvent(idx, aPar);
  Output('</td><td>');
  MyOwnLife_TableCache(idx,aPar);  //doplnime tabulku s informacemi
  Output('</td></tr></table>');
  if(not MyOwn_aCacheData[idx].bEvent) and (aPar.Values['MonthYear']='Yes')
    then MyOwnLife_MonthYear(idx, aPar);
  Output('</div>'+CRLF);
end;

//hlavni funkce modulu
function MyOwnLife_Run(aPar:TStringList):string;
var sMainItem:string;
    i:integer;
begin
  Result := '';
  //Header
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //zkontrolujeme, zda jsou vubec nejake vlastni kesky
  if(Length(MyOwn_aCacheData)=0) then begin
    AddError(_('ERR: Not found any own cache!'));
		exit;
  end;
  //vytvorime tlacitka pro zobrazeni/skryti archivivanych kesi
  sMainItem:='iMOLife'+IntToStr(iItem);
  Result:=Result+MyOwnLife_Buttons(sMainItem);
  Output(Result);
  Result:='';
  //radit kese od nejstarsi po nejmladsi
  for i:=Low(MyOwn_aCacheData) to High(MyOwn_aCacheData) do begin
    MyOwnLife_OutputCache(i,sMainItem,aPar);
  end;
end;