// Graf souctu hodnot v tagu (po mesicich za cele keskovaci obdobi,
// od prvniho nalezu do soucasnosti)

function TimelineBySumaTag_Run(aPar:TStringList):string;
var tab:TSqliteTable;
    f,fTotal,fYearly:extended;
    iMax,iMonthMin,iMonthMax,iYear,iYearAct,iYearMax,iMonth,iMonthAct,iNum:integer;
    iMonthCount,iMonthAxis,iMonthLimit,iMonthStep:integer;
    i,idx,iYyyyMin,iYyyyMax:integer;
    iHeightGr,iWidthGr,iHeightStd,iWidthStd,iYearlySeries:integer;
    s,sSql,sTranspBack,sTranspArea,sTranspVert:string;
    sColorTotal,sColorYearly,sMark:string;
    sLabelsM,sLabelsY,sTotal,sYearly,sYearlySeries,sYearlyAxis,sYchls,sYchco:string;
    bMonthsAx:boolean;
    aVal:array [0..1000] of integer; //pole mesicnich souctu a oznaceni mesicu
begin
  if(aPar.Values['TagCategory']='') then begin
    Log(_('ERR: TagCategory not set'));
    exit;
  end;
  // pepoet rozmr grafu
  iHeightStd:=355;
  iWidthStd:=680;
  iWidthGr:=iWidth;
  iHeightGr:=Round(iHeightStd*iWidthGr/iWidthStd);
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then begin
    iWidthGr:=Trunc(iWidthStd*Sqrt(MAX_GraphAreaSize/(iHeightStd*iWidthStd)));
    iHeightGr:=Trunc(iHeightStd*iWidthGr/iWidthStd);
  end;

  // limitn hodnota potu msc (nad limit se graf vykresluje s krokem dvou a vce msc kvli omezen v dlce URL) 
  iMonthLimit:=70;
  // definice prhlednost a barev
  sTranspBack:='08';
  sTranspArea:='80';
  sTranspVert:='40';
  sColorTotal:='%ColorGraphCacheTraditional%';  //celkova barva
  sColorYearly:='%ColorGraphYearlyTotals%';     //rocni barva
  // rozsahy na mtka os XY grafu
  //zjistime celkovy soucet hodnot
  Geoget_DB.AddParamText(':TagCat',aPar.Values['TagCategory']);
  sSql:='SELECT CAST(0.99+sum(gtv.value) AS integer) Value FROM'
    +' geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE dtfound>00'
    +'   AND gt.id=gc.id AND gtc.key=gt.ptrkat AND gtc.value=:TagCat'
    +' AND gtv.key=gt.ptrvalue'
    ;
  iMax:=Geoget_DB.GetTableValue(sSql);
  iMonthMin:=Geoget_DB.GetTableValue('SELECT MIN(dtfound/100) FROM geocache WHERE dtfound>0');
  iYyyyMin:=iMonthMin/100;
  //tady by asi bylo lepsi pouzit aktualni datum misto data posledniho nalezu
  //ale aby to bylo stejne jako u kumulativniho grafu, nechame to takto
  iMonthMax:=Geoget_DB.GetTableValue('SELECT MAX(dtfound/100) FROM geocache WHERE dtfound>0');
  iYyyyMax:=iMonthMax/100;
  iMonthCount:=(Trunc(iMonthMax/100)-Trunc(iMonthMin/100))*12+(iMonthMax mod 100)-(iMonthMin mod 100)+1;
  //zjistime celkovy soucet hodnot
  Geoget_DB.AddParamText(':TagCat',aPar.Values['TagCategory']);
  sSql:='SELECT CAST(0.99+sum(gtv.value) AS integer) Value FROM'
    +' geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE dtfound>00'
    +'   AND gt.id=gc.id AND gtc.key=gt.ptrkat AND gtc.value=:TagCat'
    +' AND gtv.key=gt.ptrvalue'
    +' GROUP BY dtfound/10000'
    +' ORDER BY Value desc LIMIT 1'
    ;
  iYearMax:=Geoget_DB.GetTableValue(sSql);
  // pepnae detail grafu
  iMonthStep:=1; 
  if iMonthCount>iMonthLimit then iMonthStep:=2;
  if iMonthCount>(3*iMonthLimit/2) then iMonthStep:=3;
  if iMonthCount>(6*iMonthLimit/2) then iMonthStep:=6;
  bMonthsAx:=(iMonthStep<6);
  Result:='';
  for i:=0 to High(aVal) do aVal[i]:=0; //inicializujeme mesicni soucty hodnot
  iMonthAct:=iMonthMin mod 100;
  iYearAct:=Trunc(iMonthMin/100);
  sYearly:=EncodeDataExtended(0);
  sYearlyAxis:=EncodeDataExtended(0);
  sLabelsM:='|';
  sLabelsY:='|';
  Geoget_DB.AddParamText(':TagCat',aPar.Values['TagCategory']);
  sSql:='SELECT gc.dtfound/100 YearMonth, CAST(sum(100*gtv.value) AS integer) Value FROM'
    +' geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE dtfound>00'
    +'   AND gt.id=gc.id AND gtc.key=gt.ptrkat AND gtc.value=:TagCat AND gtv.key=gt.ptrvalue'
    +' GROUP BY YearMonth';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYear:=StrToInt(Copy(s,1,4));
      iMonth:=StrToInt(Copy(s,5,2));
      idx:=(iYear-iYyyyMin)*12+iMonth-1;
      iNum:=StrToInt(tab.FieldByName['Value']); //stonasobek cisla
      aVal[idx]:=iNum;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  iYearlySeries:=0;
  for i:=iMonthMin to iMonthMax do begin
    iYear:=i/100;
    iMonth:=i mod 100;
    if(iMonth>12) or (iMonth<1) then continue;
    idx:=(iYear-iYyyyMin)*12+iMonth-1;
    inum:=aVal[idx];
    f:=(0.0+iNum)/100.;
    if (iMonth<>iMonthAct) then begin
      //seskupeni nekolika mesicu        
      if((iMonthAct mod iMonthStep)=0) then begin         
        //zmna msce (podle kroku) = byly zpracovny vechny typy ke z minulho, doplnme datov ady a labely
        iMonthAxis:=(iYearAct-Trunc(iMonthMin/100))*12+iMonthAct-(iMonthMin mod 100)+1;
        sTotal:=sTotal+EncodeNormDataExtended(round(fTotal),iMax);
        sYearly:=sYearly+EncodeNormDataExtended(round(fYearly),iYearMax);
        sYearlyAxis:=sYearlyAxis+EncodeNormDataExtended(iMonthAxis,iMonthCount);
        sLabelsM:=sLabelsM+'|'+IntToStr(iMonthAct);
        sLabelsY:=sLabelsY+'|';
        if iMonthAct=6 then sLabelsY:=sLabelsY+IntToStr(iYear);
      end;
      iMonthAct:=iMonth;
    end;
    if(iYear<>iYearAct) then begin  //kazdy rok je samostatna datova rada
      iYearlySeries:=iYearlySeries+1;
      //doplnime koncovy bod na ose, aby bylo jasne, ze se pocita od nuly
      //sYearly:=sYearly+EncodeDataExtended(0);
      //sYearlyAxis:=sYearlyAxis+EncodeNormDataExtended(iMonthAxis,iMonthCount);
      // zmna roku - vytvorime rocni soucet
      sYearlySeries:=sYearlySeries+','+sYearlyAxis+','+sYearly;
      sYchls:=sYchls+'|2,2,4';
      sYchco:=sYchco+','+sColorYearly;
      sMark:=sMark+'|v,'+sColorYearly+sTranspVert+','+IntToStr(iYearlySeries)+','+IntToStr(iMonthAxis)+',1';

      //vynaseci cara od posledniho rozniho souctu k nule
      //sYearly:=EncodeDataExtended(0)+EncodeNormDataExtended(round(fYearly),iYearMax);
      //sYearlyAxis:=EncodeNormDataExtended(iMonthAxis,iMonthCount)+EncodeNormDataExtended(iMonthAxis,iMonthCount);
      //sYearlySeries:=sYearlySeries+','+sYearlyAxis+','+sYearly
      //sYchls:=sYchls+'|1,4,0'; //tenkou plno carou
      //sYchco:=sYchco+','+sColorYearly;

      //prvn bod roku je vzdy 0
      sYearly:=EncodeDataExtended(0);
      sYearlyAxis:=EncodeNormDataExtended(iMonthAxis,iMonthCount);
      fYearly:=0;
      iYearAct:=iYear;
    end;
    fTotal:=fTotal+f;
    fYearly:=fYearly+f;
  end;

  // posledn datov bod za neuzaven msc i rok
  sTotal:=sTotal+EncodeNormDataExtended(Round(fTotal),iMax);
  iMonthAxis:=(iYearAct-Trunc(iMonthMin/100))*12+iMonthAct-(iMonthMin mod 100)+1;
  sYearly:=sYearly+EncodeNormDataExtended(Round(fYearly),iYearMax);
  sYearlyAxis:=sYearlyAxis+EncodeNormDataExtended(iMonthAxis,iMonthCount);
  sLabelsM:=sLabelsM+'|';
  if ((iMonthAct mod iMonthStep)=0) then sLabelsM:=sLabelsM+IntToStr(iMonthAct);
  sLabelsY:=sLabelsY+'|';
  if iMonthAct=6 then sLabelsY:=sLabelsY+IntToStr(iYear);
  sYearlySeries:=sYearlySeries+','+sYearlyAxis+','+sYearly;
  sYchls:=sYchls+'|2,2,4';                                                    //styl cary pro dalsi datovou radu (rok)
  sYchco:=sYchco+','+sColorYearly;                                            //barva cary pro dalsi datovou radu (rok)

  // vlastn vstup modulu
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:=
    +'<img src="http://chart.googleapis.com/chart?cht=lxy'
    +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)                       //velikost grafu
    +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')+'|c,ls,90,'
      +GlobalVarGet('ColorMainBkg')                        //vyplneni pozadi, vodorovne pruhy
      +',0.033,'+GlobalVarGet('ColorMainText')+sTranspBack+',0.033';
  if bMonthsAx then begin
    Result:=Result
    +'&chxt=r,x,y,x'                                                          //seznam os
    +'&chxl=1:'+sLabelsM+'|3:'+sLabelsY                                       //popisy os
    +'&chxs=0,'+sColorTotal+'|1,'+GlobalVarGet('ColorMainText')+'|2,'         //barvy na osach
    +sColorYearly+'|3,'+GlobalVarGet('ColorMainText');
  end else begin 
    Result:=Result
    +'&chxt=r,x,y'                                                            //seznam os
    +'&chxl=1:'+sLabelsY                                                      //popis os
    +'&chxs=0,'+sColorTotal+'|1,'+GlobalVarGet('ColorMainText')+'|2,'+sColorYearly;             //barvy na osach
  end;
  Result:=Result
    +'&chxr=0,0,'+IntToStr(iMax)+'|1,0,'+IntToStr(iMonthCount)+'|2,0,'+IntToStr(iYearMax)
    +'&chco='+sColorTotal+sYchco                                              //barvy pro datove sady
    +'&chls=3,4,0'+sYchls                                                     //styl cary
    +'&chd=e:__,'+sTotal+sYearlySeries                                        //data obou rad v jednoduchem kodovani
    +'&chm=B,'+sColorTotal+sTranspArea+',0,1,0'+sMark                         //vyplneni plochy pod prvni datovou serii
    +'" />'+CRLF;
  //vse uz je prevedeno do UTF a entit, neprevadet znovu
  //Result:=AnsiToUtf(Result);
  fOut.Write(Result,Length(Result)); //rovnou vystup, aby nebylo prekodovano
  Result:='';
end;