// Kumulativn graf nlez podle typu ke

function TimelineByTypeCumulative_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iMax,iMonthMin,iMonthMax,iYear,iYearAct,iYearMax,iMonth,iMonthAct,iNum:integer;
    iMonthCount,iMonthAxis,iMonthLimit,iMonthStep:integer;
    iWidthGr,iHeightGr,iHeightStd,iWidthStd,iCumTotal,iCumTradi,iCumMulti,iCumMyst,iCumYearly,iYearlySeries:integer;
    s,sType,sSql,sTranspBack,sTranspVert,sTranspArea:string;
    sColorTradi,sColorMulti,sColorMyst,sColorOther,sColorTotal,sColorYearly:string;
    sMark,sLabelsM,sLabelsY,sTotal,sTradi,sMulti,sMyst,sYearly,sYearlySeries,sYearlyAxis,sYchls,sYchco:string;
    bMonthsAx:boolean;
begin
  // pepoet rozmr grafu
  iHeightStd:=355;
  iWidthStd:=680;
  iWidthGr:=iWidth;
  iHeightGr:=Round(iHeightStd*iWidthGr/iWidthStd);
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then begin
    iWidthGr:=Trunc(iWidthStd*Sqrt(MAX_GraphAreaSize/(iHeightStd*iWidthStd)));
    iHeightGr:=Trunc(iHeightStd*iWidthGr/iWidthStd);
  end;

  // limitn hodnota potu msc (nad limit se graf vykresluje s krokem dvou a vce msc kvli omezen v dlce URL) 
  iMonthLimit:=60;
  // definice prhlednost a barev
  sTranspBack:='08';
  sTranspVert:='20';
  sTranspArea:='80';
  sColorTradi:=GlobalVarGet('ColorGraphCacheTraditional');
  sColorMulti:=GlobalVarGet('ColorGraphCacheMulti');
  sColorMyst:=GlobalVarGet('ColorGraphCacheUnknown');
  sColorOther:=GlobalVarGet('ColorTableScaleMinBkg');
  sColorTotal:=GlobalVarGet('ColorTableScaleAvgBkg');
  sColorYearly:=GlobalVarGet('ColorGraphYearlyTotals');

  // rozsahy na mtka os XY grafu
  iMax:=StrToInt(GlobalVarGet('FoundCachesCount'));
  iMonthMin:=Geoget_DB.GetTableValue('SELECT MIN(dtfound/100) FROM geocache WHERE dtfound>0');
  iMonthMax:=Geoget_DB.GetTableValue('SELECT MAX(dtfound/100) FROM geocache WHERE dtfound>0');
  iMonthCount:=(Trunc(iMonthMax/100)-Trunc(iMonthMin/100))*12+(iMonthMax mod 100)-(iMonthMin mod 100)+1;
  iYearMax:=Geoget_DB.GetTableValue('SELECT COUNT(*) Num FROM geocache WHERE dtfound>0 GROUP BY dtfound/10000 ORDER BY Num DESC LIMIT 1');
  // pepnae detail grafu
  iMonthStep:=1; 
  if iMonthCount>iMonthLimit then iMonthStep:=2;
  if iMonthCount>(3*iMonthLimit/2) then iMonthStep:=3;
  if iMonthCount>(6*iMonthLimit/2) then iMonthStep:=6;
  bMonthsAx:=(iMonthStep<6);
 
  Result:='';
  iMonthAct:=iMonthMin mod 100;
  iYearAct:=Trunc(iMonthMin/100);
  sYearly:=EncodeDataExtended(0);
  sYearlyAxis:=EncodeDataExtended(0);
  sLabelsM:='|';
  sLabelsY:='|';

  sSql:='SELECT dtfound/100 YearMonth, cachetype Type, count(*) Num FROM geocache WHERE dtfound>0 GROUP BY YearMonth, Type';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYear:=StrToInt(Copy(s,1,4));
      iMonth:=StrToInt(Copy(s,5,2));
      sType:=tab.FieldByName['Type'];
      iNum:=StrToInt(tab.FieldByName['Num']);
      if (iMonth<>iMonthAct) then begin         
        if ((iMonthAct mod iMonthStep)=0) then begin         
          // zmna msce (podle kroku) = byly zpracovny vechny typy ke z minulho, doplnme datov ady a labely
          iMonthAxis:=(iYearAct-Trunc(iMonthMin/100))*12+iMonthAct-(iMonthMin mod 100)+1;
          sTotal:=sTotal+EncodeNormDataExtended(iCumTotal,iMax);
          sTradi:=sTradi+EncodeNormDataExtended(iCumTradi,iMax);
          sMulti:=sMulti+EncodeNormDataExtended(iCumTradi+iCumMulti,iMax);
          sMyst:=sMyst+EncodeNormDataExtended(iCumTradi+iCumMulti+iCumMyst,iMax);
          sYearly:=sYearly+EncodeNormDataExtended(iCumYearly,iYearMax);
          sYearlyAxis:=sYearlyAxis+EncodeNormDataExtended(iMonthAxis,iMonthCount);
          sLabelsM:=sLabelsM+'|'+IntToStr(iMonthAct);
          sLabelsY:=sLabelsY+'|';
          if iMonthAct=6 then sLabelsY:=sLabelsY+IntToStr(iYear);
        end;
        iMonthAct:=iMonth;
      end;
      if iYear<>iYearAct then begin
        // zmna roku - vypodme ron kumulativ
        iYearlySeries:=iYearlySeries+1;
        sYearlySeries:=sYearlySeries+','+sYearlyAxis+','+sYearly;
        sMark:=sMark+'|v,'+sColorYearly+sTranspVert+','+IntToStr(iYearlySeries+3)+','+IntToStr(iMonthAxis)+',1';
        sYchls:=sYchls+'|2,2,4';
        sYchco:=sYchco+','+sColorYearly;
        // prvn bod ronho kumulativu je y=0
        sYearly:=EncodeDataExtended(0);
        sYearlyAxis:=EncodeNormDataExtended(iMonthAxis,iMonthCount);
        iCumYearly:=0;
        iYearAct:=iYear;
      end;
      case sType of
        'Traditional Cache':  iCumTradi:=iCumTradi+iNum;
        'Multi-cache':        iCumMulti:=iCumMulti+iNum;
        'Unknown Cache':      iCumMyst:=iCumMyst+iNum;
      end;
      iCumTotal:=iCumTotal+iNum;
      iCumYearly:=iCumYearly+iNum;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // posledn datov bod za neuzaven msc i rok
  sTotal:=sTotal+EncodeNormDataExtended(iCumTotal,iMax);
  sTradi:=sTradi+EncodeNormDataExtended(iCumTradi,iMax);
  sMulti:=sMulti+EncodeNormDataExtended(iCumTradi+iCumMulti,iMax);
  sMyst:=sMyst+EncodeNormDataExtended(iCumTradi+iCumMulti+iCumMyst,iMax);
  iMonthAxis:=(iYearAct-Trunc(iMonthMin/100))*12+iMonthAct-(iMonthMin mod 100)+1;
  sYearly:=sYearly+EncodeNormDataExtended(iCumYearly,iYearMax);
  sYearlyAxis:=sYearlyAxis+EncodeNormDataExtended(iMonthAxis,iMonthCount);
  sLabelsM:=sLabelsM+'|';
  if ((iMonthAct mod iMonthStep)=0) then sLabelsM:=sLabelsM+IntToStr(iMonthAct);
  sLabelsY:=sLabelsY+'|';
  if iMonthAct=6 then sLabelsY:=sLabelsY+IntToStr(iYear);
  sYearlySeries:=sYearlySeries+','+sYearlyAxis+','+sYearly;
  sYchls:=sYchls+'|2,2,4';
  sYchco:=sYchco+','+sColorYearly;

  // vlastn vstup modulu
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  if (iWidth <> iWidthGr) then Result := '<div align="center">'
  else Result := '';
  Result:=Result
    +'<img src="http://chart.googleapis.com/chart?cht=lxy'
    +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)
    +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')+'|c,ls,90,'
      +GlobalVarGet('ColorMainBkg')+',0.033,'
      +GlobalVarGet('ColorMainText')+sTranspBack+',0.033';
  if bMonthsAx then begin
    Result:=Result
    +'&chxt=r,x,y,x'
    +'&chxl=1:'+sLabelsM+'|3:'+sLabelsY
    +'&chxs=0,'+sColorTotal+'|1,'+GlobalVarGet('ColorMainText')+'|2,'
      +sColorYearly+'|3,'+GlobalVarGet('ColorMainText');
  end else begin 
    Result:=Result
    +'&chxt=r,x,y'
    +'&chxl=1:'+sLabelsY
    +'&chxs=0,'+sColorTotal+'|1,'+GlobalVarGet('ColorMainText')+'|2,'+sColorYearly;
  end;
  Result:=Result
    +'&chxr=0,0,'+IntToStr(iMax)+'|1,0,'+IntToStr(iMonthCount)+'|2,0,'+IntToStr(iYearMax)
    +'&chco='+sColorTotal+','+sColorMyst+sTranspArea+','+sColorMulti+sTranspArea+','+sColorTradi+sTranspArea+sYchco
    +'&chls=3,4,0|0,0,0|0,0,0|0,0,0'+sYchls
    +'&chd=e:__,'+sTotal+',__,'+sMyst+',__,'+sMulti+',__,'+sTradi+sYearlySeries
    +'&chm=b,'+sColorOther+sTranspArea+',0,1,0|b,'+sColorMyst+sTranspArea+',1,2,0|b,'+sColorMulti+sTranspArea+',2,3,0'
    +'|B,'+sColorTradi+sTranspArea+',3,4,0'+sMark
    //+'&chdl='+EncodeGoogleLabel(_('Total finds'))+'|'
    //  +EncodeGoogleLabel(_('Unknown'))+'|'+EncodeGoogleLabel(_('Multi'))
    //  +'|'+EncodeGoogleLabel(_('Traditional'))+'|'+EncodeGoogleLabel(_('Yearly finds'))
    +'&chdl='+(_('Total finds'))+'|'
      +(_('Unknown'))+'|'+(_('Multi'))
      +'|'+(_('Traditional'))+'|'+(_('Yearly finds'))
    +'&chdls='+GlobalVarGet('ColorMainText')+',12'
    +'&chdlp=b|l'
    +'" />'+CRLF;
  if (iWidth <> iWidthGr) then Result := Result + '</div>';
  //labels uz je prevedeno do UTF a entit, neprevadet znovu
  Result:=AnsiToUtf(Result);
  fOut.Write(Result,Length(Result)); //rovnou vystup, aby nebylo prekodovano
  Result:='';
end;