// asov ada msnch nlez

function TimelineMonthly_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iY,iM,iMax,iYearMin,iYearMax,iMonthMin,iMonthMax:integer;
    iBars,iWidthGr,iHeightGr,iBarSp,iBarWd,iStepLabels:integer;
    s,ss,sData,sLabM, sLabY,sSql:string;
    aData:TStringList;
begin
  // rozmry a parametry grafu
  iHeightGr:=250;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  iStepLabels:=3;                             // krok popisk vodorovn osy
  if iWidthGr<400 then iStepLabels:=6;

  // pprava dat pro graf
  aData:=TStringList.Create();
  sSql:='SELECT dtfound/100 YearMonth, count(*) Count FROM geocache WHERE dtfound>0 GROUP BY YearMonth';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYearMax:=StrToInt(Copy(s,1,4));
      iMonthMax:=StrToInt(Copy(s,5,2));
      s:=IntToStr(iYearMax)+IntToStr(iMonthMax);
      if iYearMin=0 then iYearMin:=iYearMax;
      if iMonthMin=0 then iMonthMin:=iMonthMax;
      ss:=tab.FieldByName['Count'];
      if StrToInt(ss)>iMax then iMax:=StrToInt(ss);
      aData.Add(s+'='+ss);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // rozmry a parametry grafu
  iBars:=(iYearMax-iYearMin)*12+iMonthMax-iMonthMin;  // poet sloupc histogramu
  iBarSp:=1;                                          // mezera mezi bary histogramu
  iBarWd:=Trunc((iWidthGr-30)/iBars)-iBarSp;          // ka baru histogramu

  // generovn datovch ad a popis
  iY:=iYearMin;
  iM:=iMonthMin;
  while true do begin
    s:=aData.Values[IntToStr(iY)+IntToStr(iM)];
    if s='' then s:='0';
    if(sData='') then sData:=s else sData:=sData+','+s;
    if (iM mod iStepLabels)=0 then sLabM:=sLabM+'|'+IntToStr(iM) else sLabM:=sLabM+'|';
    if iM=6 then sLabY:=sLabY+'|'+IntToStr(iY) else sLabY:=sLabY+'|';
    Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if ((iY=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax) then break;
  end;

  // finln akce
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:='<img src="http://chart.googleapis.com/chart?cht=bvs'
         +'&chs='+IntToStr(iWidthGr)+'x'+IntToStr(iHeightGr)
         +'&chf=bg,s,'+GlobalVarGet('ColorMainBkg')
         +'&chco='+GlobalVarGet('ColorTableScaleAvgBkg')
         +'&chbh='+IntToStr(iBarWd)+','+IntToStr(iBarSp)
         +'&chg=0,'+FormatFloatDot('0.00',GraphAxisStep(iMax)*100.0/iMax)+',3,3,0,0'
         +'&chds=0,'+IntToStr(iMax)
         +'&chxt=x,y,x'
         +'&chxs=0,'+GlobalVarGet('ColorMainText')+',12|1,'
           +GlobalVarGet('ColorMainText')+',12|2,'
           +GlobalVarGet('ColorMainText')+',12'
         +'&chxr=1,0,'+IntToStr(iMax)+','+IntToStr(GraphAxisStep(iMax))
         +'&chd=t:'+sData
         +'&chxl=0:'+sLabM+'|2:'+sLabY
         +'" />'+CRLF;
  //tady nejsou zadne znaky, ktere by bylo treba prevadet do UTF
  //Result:=AnsiToUtf(Result);  // prevedeme na utf
  fOut.Write(Result,Length(Result));
  Result:='';
  // klid
  if(aData<>nil) then aData.Free();
end;